/*
 *       2015oct15  Samukawa
 *
 *   g++ LU.cpp longint.o rational.o ratutil.o mempool.o gettimeofday.o
 *
 *   ./a.exe
 *   6 5 4
 *
	  m = n = r   regular (non singular) matrix
	  m = n > r   singular matrix of rank r
	  m > n > r   non singular but pivoting occurs at n
 *
 * */

#include <stdexcept>
#include "longint.h"
#include "rational.h"
#include "ratutil.h"
#include "rblas.h"
#include "rvector.h"
#include "rmatrix.h"

long long gettime();

int main() 
{
	int m,n,r,rank;
	long long iseed=1;
	long long tstart = gettime();

	std::cout << "enter m n r: "; std::flush(std::cout);
	std::cin >> m ;
	std::cin >> n ;
	std::cin >> r ;
	std::cout <<  "m=" << m << " n=" << n << "  r=" << r << std::endl;

	rat::matrix<rational> a(m,m), x(m,m);
	rat::vector<int> ipvt(m), jpvt(m);
				//  Generate m x m Matrix
	GenMat(a,m,n,r,iseed);	//  its n x n leading submatrix is rank r
				//  m = n = r   regular (non singular) matrix
	matprt(a,m,m);		//  m = n > r   singular matrix of rank r
				//  m > n > r   non singular but pivoting occurs at n

	tstart = gettime();
	solhmg(a,m,rank,x);
	std::cout << "solhmg time=" << (double)(gettime()-tstart)/1000000.0 << "(sec)" << std::endl;
//	matprn(a,n,n);

	if(rank < m){
		std::cout << "X matrix  m-rank-2=" << m-rank-1  << std::endl;
		for (int i=0; i < m; ++i) {
			for (int j=0; j <= m-rank-1; ++j){
				std::cout << " " << -x[i][j];
			}
			std::cout <<  std::endl;
		}
	}
}
