/*
 * g++ -O3 -DEPROF2 PiCfracAtanInt.cpp rational.o longint.o interval.o rough.o numeric_cast.o mempool.o thread_manager.o gettimeofday.o
 *     S. Kobayashi "En no Suugaku" p.51
 */
#include <math.h>
#include <iostream>
#include "longint.h"
#include "rational.h"
#include "ratutil.h"
#include "interval.h"

int main()
{
	std::cout << "input n=" << std::endl;
	int n;
	std::cin >> n ;
	uint32_t m;
	longint p,q,t,r,s,u,x,tmp;
	rational pipq,pirs;
//	longint::lgcd_p=longint::lgcd;  // 4sec --> 43sec (n=1000)
	longint::lgcd_p=longint::lgcd1;  // ???????????????????????
	long long tstart0=gettime();
	m=n;
	p=m*m;
	q=2u*m+1u;
//	t=p+q*(2u*(m-1u)+1u);
	tmp=2u*(m-1u)+1u;
	t=p+q*tmp;
//	p=q*(m-1u)*(m-1u);
	tmp=(m-1u)*(m-1u);
	p=q*tmp;
	q=t;
	r=(m-1u)*(m-1u);
	s=2u*(m-1u)+1u;
	for(uint32_t i=n-2; i>0; i--){
		x=i;
		t=p+q*(longint::TWO*x+longint::ONE);
		u=r+s*(longint::TWO*x+longint::ONE);
		p=q*x*x;
		r=s*x*x;
		q=t;
//		longint g=longint::lgcd2(p,t); p=p/g; q=t/g;
		longint g=longint::lgcd2(p,t);
		std::cout << "  i=" << i << " gcd=" << g << std::endl;
		s=u;
	}
	t=p+q;
	p=q;
	q=t;
	u=r+s;
	r=s;
	s=u;
	std::cout << "PiCfracAtanInt loop finish. total time=" << (double)(gettime()-tstart0)/1000000.0 << "(sec)" << std::endl;
//	pipq=RRset(p,q)*rational::FOUR;
	pipq=RRset(p,q);
	std::cout << "PiCfracAtanInt pipq finish. total time=" << (double)(gettime()-tstart0)/1000000.0 << "(sec)" << std::endl;
//	pirs=RRset(r,s)*rational::FOUR;
	pirs=RRset(r,s);
	std::cout << "PiCfracAtanInt pirs finish. total time=" << (double)(gettime()-tstart0)/1000000.0 << "(sec)" << std::endl;
	interval y;
	if( pipq >= pirs){
		y=interval(pirs,pipq);
	}else{
		y=interval(pipq,pirs);
	}
	std::cout << "PiCfracAtanInt interval finish. total time=" << (double)(gettime()-tstart0)/1000000.0 << "(sec)" << std::endl;
	y=y*rational::FOUR;
	std::cout << " pi="; formatprn(y);
	longint pin=pipq.numerator(); longint pid=pipq.denominator();
	std::cout << " num dgts of pi=" << numdgts(pin) << " " << numdgts(pid) << std::endl;
	std::cout << " num dgts of p=" << numdgts(p) << " q=" << numdgts(q) << std::endl;
	std::cout << " num dgts of r=" << numdgts(r) << " s=" << numdgts(s) << std::endl;
	std::cout << "PiCfracAtanInt finish. total time=" << (double)(gettime()-tstart0)/1000000.0 << "(sec)" << std::endl;
#ifdef EPROF2
	std::cout << "lgcd2time=" << (double)longint::lgcd2time/1000000.0 << " lgcd2count=" << longint::lgcd2count  << std::endl;
	std::cout << "lgcdtime=" << (double)longint::lgcdtime/1000000.0 << " lgcdcount=" << longint::lgcdcount  << std::endl;
	std::cout << "ldividetime=" << (double)longint::ldividetime/1000000.0 << " ldividecount=" << longint::ldividecount  << std::endl;
//	std::cout << "opsubeqtime=" << (double)longint::opsubeqtime/1000000.0 << " opsubeqcount=" << longint::opsubeqcount  << std::endl;
	std::cout << "shrtime=" << (double)longint::shrtime/1000000.0 << " shrcount=" << longint::shrcount  << std::endl;
	std::cout << "lmultime=" << (double)longint::lmultime/1000000.0 << " lmulcount=" << longint::lmulcount  << std::endl;
	std::cout << "laddtime=" << (double)longint::laddtime/1000000.0 << " laddcount=" << longint::laddcount  << std::endl;
#endif

	return 1;
}
