/*
 *     S. Kobayashi "En no Suugaku" p.51
 * 
 *
 *  n=20000    
 *    k=  1.5   1.6   1.7   1.8  1.9   2.0   2.1  2.2   
 *        9.4   9.1   9.2   8.8  8.6   8.9   8.7  9.0 (sec on E440)
 */
#include <math.h>
#include <iostream>
#include "longint.h"
#include "rational.h"
#include "interval.h"
#include "ratutil.h"

#define LGCD1

int main()
{
	uint32_t n;
	double k;
	std::cout << "input n=" << std::endl;
	std::cin >> n ;
#ifdef LGCD1
	std::cout << "input k=" << std::endl;
	std::cin >> k ;
#endif
	rational p,q,t,r,s,u,x,xx,tmp;
	rational pit,piu;
	long long tstart0=gettime();
#ifdef LGCD1
	std::cout << "LGCD1 defined.  USE lgcd1 for lgcd_p" << std::endl;
	longint::lgcd_p = longint::lgcd1;
#endif
	p=n*n;
	q=2*n+1;
	tmp=2u*(n-1u)+1u;
	t=p+q*tmp;           //  n^2+(2n+1)*(2n-1)
	tmp=(n-1u)*(n-1u);
	p=q*tmp;         q=t;            t=p/q; // t = (2n+1)*(n-1)^2 / (n^2+(2n+1)*(2n-1))
	r=(n-1u)*(n-1u); s=2u*(n-1u)+1u; u=r/s; // u = (n-1)^2 / 2(n-1)+1
	interval v;
	if( t >= u){
		v=interval(u,t);
	}else{
		v=interval(t,u);
	}
	rational vlow=v.lower();
	int lastdgts=getdgts(vlow);       //  set number of digits in lastdgts
	for(uint32_t i=n-2; i>0; i--){
		x=i; xx=x*x;
		interval z=v+(rational::TWO*x+rational::ONE);
		interval w=z.inv();
#ifdef LGCD1
		rational vlow=v.lower();  //  lower number picked for getdgts();
		if((double)getdgts(vlow)/(double)lastdgts >= k){   // check digits increase
			longint::lgcd_p = longint::lgcd2;
			v=w*xx;
			longint::lgcd_p = longint::lgcd1;
			vlow=v.lower(); lastdgts=getdgts(vlow); // set number of digits in lastdgts
			std::cout << "iteration i=" << i << " lastdgts=" << lastdgts <<  std::endl;
		}else{
			v=w*xx;
		}
#else
		v=w*xx;
#endif
//		std::cout << "  v="; formatprn(v);
	}
	std::cout << "PiCfracAtanRint loop finish. total time=" << (double)(gettime()-tstart0)/1000000.0 << "(sec)" << std::endl;
	//------------------------------------------------------
	vlow=v.lower(); rational vup=v.upper();
	std::cout << "numdgts lower=" << getdgts(vlow) << " and  upper=" << getdgts(vup) << std::endl;
	//------------------------------------------------------
	v=v+rational::ONE;
	interval y=v.inv();
	longint::lgcd_p = longint::lgcd2;  //    FORCE lgcd2 for *4 operation
	y=y*rational::FOUR;
#ifdef EPROF2
	std::cout << " lgcd2count=" << longint::lgcd2count  << std::endl;
#endif
	std::cout << " pi="; formatprn(y);
#ifdef EPROF2
	std::cout << " lgcd2count=" << longint::lgcd2count  << std::endl;
#endif
#ifdef LGCD1
	std::cout << "LGCD1 defined.  USE lgcd1 for lgcd_p" << std::endl;
	longint::lgcd_p = longint::lgcd1;
#endif
	//-----------------------------------------
	rational vl=y.lower();
	std::cout << " num dgts of pi (after lgcd2) =" << getdgts(vl) << std::endl;
	//-----------------------------------------
	std::cout << "PiCfracAtanRint finish. total time=" << (double)(gettime()-tstart0)/1000000.0 << "(sec)" << std::endl;
	/***************************************************
	for(uint32_t i=1; i<5; i++){
		y=y*rational::MILLION;
	}
	std::cout << "Lpi="; formatprn(y);
	***************************************************/
#ifdef EPROF2
	std::cout << "lgcd2time=" << (double)longint::lgcd2time/1000000.0 << " lgcd2count=" << longint::lgcd2count  << std::endl;
	std::cout << "lgcdtime=" << (double)longint::lgcdtime/1000000.0 << " lgcdcount=" << longint::lgcdcount  << std::endl;
	std::cout << "ldividetime=" << (double)longint::ldividetime/1000000.0 << " ldividecount=" << longint::ldividecount  << std::endl;
//	std::cout << "opsubeqtime=" << (double)longint::opsubeqtime/1000000.0 << " opsubeqcount=" << longint::opsubeqcount  << std::endl;
	std::cout << "shrtime=" << (double)longint::shrtime/1000000.0 << " shrcount=" << longint::shrcount  << std::endl;
	std::cout << "lmultime=" << (double)longint::lmultime/1000000.0 << " lmulcount=" << longint::lmulcount  << std::endl;
	std::cout << "laddtime=" << (double)longint::laddtime/1000000.0 << " laddcount=" << longint::laddcount  << std::endl;
#endif

	return 1;
}
