/*
 * interval.h
 *
 *  Created on: 2015/06/16
 *      Author: Osamu
 */

#ifndef INTERVAL_H_
#define INTERVAL_H_

#include <string>
#include "rational.h"
//#include "rvector.h"
//#include "rmatrix.h"


//namespace rat {

class interval {
	rational l_;
	rational u_;
public:
	interval() : l_(rational(0u)), u_(rational(0u)) {}
	interval(rational const& a, rational const& b) : l_(a), u_(b) {}
	interval(const interval& b);
	virtual ~interval();

	rational lower() const { return l_; }
	rational upper() const { return u_; }
	interval neg();
	interval inv();

	interval& operator=(interval b);
	interval operator+(rational const& y) const;
	interval operator+(interval const& b) const;
	interval operator-(interval const& b) const;
	interval operator*(rational const& y) const;
	interval operator*(interval const& b) const;
	bool operator==(interval const& b) const;

	std::string format(const int w, const int d) const;
};

double log10int(const interval& a);
void formatprn(const interval& x);
std::ostream& operator<<(std::ostream& o, interval const& a);

//} /* namespace rat */

#endif /* INTERVAL_H_ */
