/*
 * longint_cexp.h
 *
 *  Created on: 2012/09/16
 *      Author: Osamu
 */

#ifndef LONGINT_CEXP_H_
#define LONGINT_CEXP_H_

template<int i> struct Log2
{
    static const int result = 1 + Log2<i/2>::result;
};

template<> struct Log2<1>
{
	static const int result = 0;
};

template<int min, int max> struct Poolvsize
{
	static const int result = Log2<max>::result - Log2<min>::result + 1;
};

template <bool cond, typename Then, typename Else>
struct IF
{
	typedef Then RET;
};

template <typename Then, typename Else>
struct IF<false, Then, Else>
{
	typedef Else RET;
};

// for 32bit-64bit compiler compatibility

#ifndef _STDINT_H
typedef IF<sizeof(int) == 4,
			int,
			long int
		>::RET int32_t;		// 32-bit signed int

typedef IF<sizeof(unsigned int) == 4,
			unsigned int,
			long unsigned int
		>::RET uint32_t;		// 32-bit unsigned int

typedef IF<sizeof(long int) == 8,
			long int,
			long long int
		>::RET int64_t;		// 64-bit signed int

typedef IF<sizeof(long unsigned int) == 8,
			long unsigned int,
			long long unsigned int
		>::RET uint64_t;		// 64-bit unsigned int

#endif
#endif /* LONGINT_CEXP_H_ */

