/*
 * mempool.cpp
 *
 *  Created on: 2013/01/16
 *      Author: goda
 */
#include <iostream>
#include <stdexcept>
#include "mempool.h"

mem_pool::mem_pool() {
	int maxidx, sz;
	// std::cout << "mem_pool(): this=" << this << std::endl;
	_midx = 0;
	_psize = new int[Poolvsize<MINDIGITS,MAXDIGITS>::result];
	_poolv = new void*[Poolvsize<MINDIGITS,MAXDIGITS>::result];
#ifdef MEMSTAT
	_numallocv = new long[Poolvsize<MINDIGITS,MAXDIGITS>::result];
	_numfreev = new long[Poolvsize<MINDIGITS,MAXDIGITS>::result];
	_numhitv = new long[Poolvsize<MINDIGITS,MAXDIGITS>::result];
#endif
	maxidx = 0;
	sz = mindigits;
	while (sz < maxdigits) { sz *= 2; ++maxidx; }
	for (int i=0, sz = mindigits; i < _poolvsize; sz *= 2, ++i) {
		_psize[i] = sz;
		_poolv[i] = 0;
#ifdef MEMSTAT
		_numallocv[i] = 0;
		_numfreev[i] = 0;
		_numhitv[i] = 0;
#endif
	}

}

mem_pool::~mem_pool() {
}

uint32_t* mem_pool::dalloc(int idx) {
	uint32_t* d;
	if (_poolv[idx] == 0) {
		int size = _psize[idx];
		d = new uint32_t[size];
	} else {
		d = (uint32_t*)_poolv[idx];
		_poolv[idx] = ((void**)_poolv[idx])[0];
#ifdef MEMSTAT
		++_numhitv[idx];
#endif
	}
#ifdef MEMSTAT
	++_numallocv[idx];
#endif
	return d;
}

void mem_pool::dfree(uint32_t* d,int idx) {
	((void**)d)[0] = _poolv[idx];
	_poolv[idx] = (void*)d;
#ifdef MEMSTAT
	++_numfreev[idx];
#endif
}

int mem_pool::getpoolindex(int size, int id) {
	int idx, sz;
	if (size < mindigits || size > maxdigits) {
		std::cout << "mem_pool::getpoolindex: size out of valid range (size=" << size << ", id="
				<< id << ")" << std::endl;
		throw std::runtime_error("memory allocation error");
	}
	idx = 0;
	sz = mindigits;
	while (sz < size) { sz *= 2; ++idx; }
	return idx;
}

