/*
 * mempool.h
 *
 *  Created on: 2013/01/16
 *      Author: goda
 */

#ifndef MEMPOOL_H_
#define MEMPOOL_H_

#include "longint_cexp.h"
#define MINDIGITS 64
#define MAXDIGITS 32768

class mem_pool {
public:
	static const int mindigits = MINDIGITS;	// should be power of 2
	static const int maxdigits = MAXDIGITS;
	static const int _poolvsize = Poolvsize<MINDIGITS,MAXDIGITS>::result;
	mem_pool();
	virtual ~mem_pool();

	int getpoolindex(int size, int id);
	uint32_t* dalloc(int idx);
	void dfree(uint32_t* p,int idx);
	inline int psize(int idx) { return _psize[idx]; }
#ifdef MEMSTAT
	long* getNumAllocv() { return _numallocv; }
	long* getNumFreev() { return _numfreev; }
	long* getNumHitv() { return _numhitv; }
#endif
private:
	int _midx;
	int* _psize;
	void** _poolv;
#ifdef MEMSTAT
	long* _numallocv;
	long*_numfreev;
	long* _numhitv;
#endif
};

#endif /* MEMPOOL_H_ */
