#include <iostream>
#include <cmath>
#include <cfloat>
#include "numeric_cast.h"

namespace rat
{

template<>
rough numeric_cast<rough,longint>(longint const& n) {
	int exp = 0;
	double mant = longint2double(n,exp);
	return rough(mant,exp);
}

template<>
rough numeric_cast<rough,rational>(rational const& s) {
	int sign = s < rational::ZERO ? -1 : 1;
	longint n = s.numerator();
	longint d = s.denominator();
	int nsz = numbits(n);
	int dsz = numbits(d);
	int exp = 0;
	if (nsz < dsz + DBL_MANT_DIG + 1) {
		int shifts = dsz + DBL_MANT_DIG - nsz;
		n <<= shifts;
		exp -= shifts;
	}
	double mant = sign*longint2double(n/d,exp);
	return rough(mant,exp);
}


template<>
rough numeric_cast<rough,uint32_t>(uint32_t const& n) {
	return rough(static_cast<double>(n),0);
}

}
