 #include <math.h>
 #include <iostream>
 #include <iomanip>    // setprecision
 #include <string>
 #include "longint.h"
 #include "rational.h"
 #include "rough.h"
 #include "numeric_cast.h"
 #include "rvector.h"
 #include "rmatrix.h"
 #include "ratutil.h"
 #include "rblas.h"
 #include "prblas.h"
// #define BISECTSHIFT
//#define SEEMATNUMDGTS
//#define HESFRBRSCAL
//#define CHKUNDERPOINTESTIMATION
//#define USEBINOMINALSERIES
//#define SQRT2NAIVE  //
#define SQRESTIMATEROOT
//#define SQRCHK
//#define CHKPRTOUT
#define ROUGHCHECK
//#define SQRCHKPRT
 
 //using namespace std;
using namespace rat;
 
 int totalit;   //  it is used in bisect, bisectrf, bisect, bisectrf.
 long long timeSQR;                   //timer for SQRint
 long long timeround;                 //timer for SQRint
 long long timeSQR1;                  //timer for SQR
 long long timeSQR2;                  //timer for SQR
 long long timeSQR3;                  //timer for SQR
 long long timesqrt4g1;               //timer for sqrt4g
 long long timesqrt4g2;               //timer for sqrt4g
 long long timesqrt4g3;               //timer for sqrt4g
 long long timesqrt4g4;               //timer for sqrt4g
 long long timesqrt4g5;               //timer for sqrt4g
 long long timesqrt4g6;               //timer for sqrt4g
 long long gettime();

 const double PI=4.0*atan(1L);  // use in jacobev

int getdgts(rational v){
	longint xd=v.denominator(); 
	longint xn=v.numerator();
	return numdgts(xd)+numdgts(xn);
}

 void MatDgtCount(const rat::matrix<rational>& a, const int m, const int n){
     int i,j, ndgta=0;
     for (i=0; i < m; ++i) {
 	for (j=0; j < n; ++j) {
 	    longint ad = a[i][j].denominator();
            longint an = a[i][j].numerator();
 	    ndgta=ndgta+numdgts(ad)+numdgts(an);
 	}
     }
     std::cout << "MatDgtCount Average NumDgts=" << (double)ndgta / (double)(m*n) << std::endl;
 }
 
 void MatDgtCountPrt(const rat::matrix<rational>& a, const int m, const int n){
     int i,j, ndgta=0;
     std::cout << "MatDgtCountPrt m=" << m << " n" << n << std::endl;
     for (i=0; i < m; ++i) {
 	for (j=0; j < n; ++j) {
 	    longint ad = a[i][j].denominator();
            longint an = a[i][j].numerator();
 	    ndgta=ndgta+numdgts(ad)+numdgts(an);
	    std::cout << numdgts(ad)+numdgts(an) << " " ;
 	}
     	std::cout << std::endl;
     }
     std::cout << "MatDgtCountPrt Average NumDgts=" << (double)ndgta / (double)(m*n) << std::endl;
 }
 
 void MtrDgtCount(const rat::matrix<rational>& a, const int n){
     int i,j, ndgta=0;
     std::cout << "MtrDgtCountPrt n=" << n << std::endl;
     for (i=0; i < n; ++i) {
         for (j=i; j < n; ++j) {
 	    longint ad = a[i][j].denominator();
            longint an = a[i][j].numerator();
 	    ndgta=ndgta+numdgts(ad)+numdgts(an);
         }
     }
     std::cout << "MtrDgtCount Average NumDgts=" << (double)ndgta / (double)((n+1)*n/2) << std::endl;
 }
 
 void MtrDgtCountPrt(const rat::matrix<rational>& a, const int n){
     int i,j, ndgta=0;
     std::cout << "MtrDgtCountPrt n=" <<  n << std::endl;
     for (i=0; i < n; ++i) {
         for (j=i; j < n; ++j) {
 	    longint ad = a[i][j].denominator();
            longint an = a[i][j].numerator();
 	    ndgta=ndgta+numdgts(ad)+numdgts(an);
	    std::cout << numdgts(ad)+numdgts(an) << " " ;
         }
     	 std::cout << std::endl;
     }
     std::cout << "MtrDgtCount Average NumDgts=" << (double)ndgta / (double)((n+1)*n/2) << std::endl;
 }
 
 void VctDgtCount(const rat::vector<rational>& a, const int m){
     int i, ndgta=0;
     for (i=0; i < m; ++i) {
         longint ad = a[i].denominator();
         longint an = a[i].numerator();
         ndgta=ndgta+numdgts(ad)+numdgts(an);
     }
     std::cout << "VctDgtCount Average NumDgts=" << (double)ndgta / (double)(m) << std::endl;
 }

 void SeeMatDiag(const rat::matrix<rational>& a, const int n){
 	for (int i=0; i < n; ++i){
 		longint xd = a[i][i].denominator(); longint xn = a[i][i].numerator();
 		std::cout << "d_{" << i << "}=" << a[i][i].format(30,20)  << " NumDgts N/D=" << numdgts(xn) << " / " << numdgts(xd) <<  "  =\\frac{" << xn << "}{" << xd << "}" << std::endl;
 	}
 }

//void RedMatDgt(rat::matrix<rational>& a, const int n, const longint crit)
//{
////	std::cout << "reduce digits" << std::endl;
// 	for (int i=0; i < n-1; ++i){
// 		for (int j=i+1; j < n; ++j){
//			longint ain= a[i][i].numerator(); longint ajd = a[j][j].denominator();
//			if(ain > crit && ajd > crit){
//				longint g=longint::lgcd2(ain,ajd);
//				if(g != longint::ONE){
//					/**************************************
// 					longint xd = a[i][i].denominator(); longint xn = a[i][i].numerator();
// 					std::cout << "gcd=" << g  << std::endl;
// 					std::cout << "a_{" << i+1 << "," << i+1 << "}=\\frac{" << xn << "}{" << xd << "}    ";
// 					xd = a[j][j].denominator(); xn = a[j][j].numerator();
// 					std::cout << "a_{" << j+1 << "," << j+1 << "}=\\frac{" << xn << "}{" << xd << "}" << std::endl;
//					**************************************/
//					a[i][i].N=longint::ldivide(a[i][i].N,g,0);
//					a[j][j].D=longint::ldivide(a[j][j].D,g,0);
//					/**************************************
// 					xd = a[i][i].denominator(); xn = a[i][i].numerator();
// 					std::cout << "a_{" << i+1 << "," << i+1 << "}=\\frac{" << xn << "}{" << xd << "}    ";
// 					xd = a[j][j].denominator(); xn = a[j][j].numerator();
// 					std::cout << "a_{" << j+1 << "," << j+1 << "}=\\frac{" << xn << "}{" << xd << "}" << std::endl;
//					**************************************/
//				}
//			}
// 		}
// 	}
//}
//
//void RedVecDgt(rat::vector<rational>& a, const int n, const longint crit)
//{
////	std::cout << "reduce digits" << std::endl;
// 	for (int i=0; i < n-1; ++i){
// 		for (int j=i+1; j < n; ++j){
//			longint ain= a[i].numerator(); longint ajd = a[j].denominator();
//			if(ain > crit && ajd > crit){
//				longint g=longint::lgcd2(ain,ajd);
//				if(g != longint::ONE){
// 					longint xd = a[i].denominator(); longint xn = a[i].numerator();
// 					std::cout << "gcd=" << g  << std::endl;
// 					std::cout << "a_{" << i+1 << "," << i+1 << "}=\\frac{" << xn << "}{" << xd << "}    ";
// 					xd = a[j].denominator(); xn = a[j].numerator();
// 					std::cout << "a_{" << j+1 << "," << j+1 << "}=\\frac{" << xn << "}{" << xd << "}" << std::endl;
//					a[i].N=longint::ldivide(a[i].N,g,0);
//					a[j].D=longint::ldivide(a[j].D,g,0);
// 					xd = a[i].denominator(); xn = a[i].numerator();
// 					std::cout << "a_{" << i+1 << "," << i+1 << "}=\\frac{" << xn << "}{" << xd << "}    ";
// 					xd = a[j].denominator(); xn = a[j].numerator();
// 					std::cout << "a_{" << j+1 << "," << j+1 << "}=\\frac{" << xn << "}{" << xd << "}" << std::endl;
//				}
//			}
// 		}
// 	}
//}

 void ScalMat(const rat::matrix<rational>& a, const int m, const int n, rat::vector<rational>& as, rat::matrix<rational>& aa)
 {
 	int i, j;
 	longint sd, sn, gcdd, gcdn;
 	rational t;
 	for (j=0; j < n; ++j) {
 		gcdd = a[0][j].denominator();
 		gcdn = a[0][j].numerator();
 		for (i=1; i < m; ++i) {
 			sd = a[i][j].denominator();
 			sn = a[i][j].numerator();
 			gcdd=(*longint::lgcd_p)(gcdd,sd); // 2015jun09
 			gcdn=(*longint::lgcd_p)(gcdn,sn); // 2015jun09
 		}
 		rational t = RRset(gcdn, gcdd);
 		as[j] = t;
// 		for (i=0; i < m; ++i) aa[i][j] = a[i][j] / t;
 		for (i=0; i < n; ++i) aa[i][j] = 0;
		rat::lmatrix_column<rational> aacol(aa,j,0,m-1,1);  // 2016jan26
#ifdef RBLAS
//		rat::raxpy(rational::ONE/t,a.column(j,0,m-1,1),aa.lcolumn(j,0,m-1,1));
		rat::raxpy(rational::ONE/t,a.column(j,0,m-1,1),aacol);
#else
//		rat::praxpy(rational::ONE/t,a.column(j,0,m-1,1),aa.lcolumn(j,0,m-1,1));
		rat::praxpy(rational::ONE/t,a.column(j,0,m-1,1),aacol);
#endif
 	}
 }
 
 void ScalVec(const rat::vector<rational>& a, const int n, rational& s, rat::vector<rational>& b, const int update)
 {
 	int i;
 	longint sd, sn, gcdd, gcdn;
 	gcdd = a[0].denominator();
 	gcdn = a[0].numerator();
 	for (i=1; i < n; ++i) {
 		sd = a[i].denominator();
 		sn = a[i].numerator();
 		if(gcdd != longint::ZERO && sd != longint::ZERO) gcdd=(*longint::lgcd_p)(gcdd,sd); 
 		if(gcdn != longint::ZERO && sn != longint::ZERO) gcdn=(*longint::lgcd_p)(gcdn,sn); 
 	}
 	s = RRset(gcdn, gcdd);
 	if(s != rational::ZERO){
 		if(update == 1){
// 			for (i=0; i < n; ++i) b[i] = a[i] / s;
 			for (i=0; i < n; ++i) b[i] = 0;
#ifdef RBLAS
			rat::raxpy(rational::ONE/s,a,b);
#else
			rat::praxpy(rational::ONE/s,a,b);
#endif
 		}
 	}
 }
 
 rational ScalMatCol(rat::matrix<rational>& a, const int m, const int n, const int j, const int update)
 {
 	rat::vector<rational> y(m), z(m);
 	rational s;
// 	for (int k=0; k < m; ++k) y[k]=a[k][j];
#ifdef RBLAS
		rat::rcopy(a.column(j,0,m-1,1),y);
#else
		rat::prcopy(a.column(j,0,m-1,1),y);
#endif
 	ScalVec(y,m,s,z,update);
 	if(update == 1){
// 		for (int k=0; k < m; ++k) a[k][j]=z[k];
		rat::lmatrix_column<rational> acol(a,j,0,m-1,1);  // 2016jan26
#ifdef RBLAS
//		rat::rcopy(z,a.lcolumn(j,0,m-1,1));
		rat::rcopy(z,acol);
#else
//		rat::prcopy(z,a.lcolumn(j,0,m-1,1));
		rat::prcopy(z,acol);
#endif
 	}
 	return s;
 }
 
 int polydivchk(rat::vector<rational>& u, const int m, const rat::vector<rational>& v, const int n, rat::vector<rational>& q, rat::vector<rational>& r){
 	for (int k=m-n; k>=0; k--){
 		q[k] = u[n+k] / v[n];
 		for (int j=n+k-1; j>=k; j--) u[j] = u[j] - q[k] * v[j-k];
 	}
 	int rtnval=1;
 	for (int j=0; j<=n-1; j++){
 		r[j] = u[j];
 		if(r[j] != rational::ZERO) rtnval=0;
 	}
 	return rtnval;
 }
 
 int getpolynomial(const int k, rat::vector<rational>& cof, const int npolynomial, const rat::vector<int>& ppolynomial, const rat::vector<rational>& cpolynomial){
 	int i,i1,i2;
 	if(k>npolynomial){
 		std::cout << "getpolynomial error npolynomial=" << npolynomial << " smaller than the first argument=" << k << std::endl;
 		exit(1);
 	}
 	i1=ppolynomial[k-1];
 	i2=ppolynomial[k];
 	for(i=i1; i<i2; i++) cof[i-i1]=cpolynomial[i];
 	return i2-i1-1;
 }
 
 int putpolynomial(const int nsize, const rat::vector<rational>& cof, int npolynomial, rat::vector<int>& ppolynomial, rat::vector<rational>& cpolynomial){
 	int i,i1,i2;
 	i1=ppolynomial[npolynomial];
 	i2=i1+nsize+1;
 	for(i=i1; i<i2; i++){ 
 		cpolynomial[i]=cof[i-i1];
 	}
 	npolynomial++;
 	ppolynomial[npolynomial]=i2;
 	return npolynomial;
 }
 
 void polytexform(const rat::vector<rational>& p, const int nsize)
 {
 	for (int i=0; i<=nsize; i++){
 		if( p[i] > rational::ZERO ){
 			std::cout << "+" << p[i] << "*x^" << nsize-i << " " << std::endl;
 		}else{
 			std::cout << p[i] << "*x^" << nsize-i << " " << std::endl;
 		}
 	}
 	std::cout << std::endl;
 }
 
 void polytexformr(const rat::vector<rational>& p, const int nsize)
 {
 	rat::vector<rational> q(nsize+1);
 	for (int j=0; j<=nsize; j++){ q[nsize-j]=p[j]; }
 	polytexform(q,nsize);
 }
 
 void polytexform2(const rat::vector<rational>& p,const int nsize, const rational& lcm)
 {
 	rational q;
 	for (int i=0; i<=nsize; i++){
 		q=p[i];
 		if(lcm != rational::ZERO){
 			for(int j=0; j < i; j++) q=q/lcm;
 		}
 		if( p[i] > rational::ZERO ){
 			std::cout << "% +" << q << "*x^" << nsize-i << "  =  ";
 			std::cout << (double)q << "*x^" << nsize-i << " " << std::endl;
 		}else{
 			std::cout << "% " << q << "*x^" << nsize-i << " = ";
 			std::cout << (double)q << "*x^" << nsize-i << " " << std::endl;
 		}
 	}
 	std::cout << std::endl;
 }
 
 void polytexformr2(const rat::vector<rational>& p, const int nsize, const rational& lcm)
 {
 	rat::vector<rational> q(nsize+1);
 	for (int j=0; j<=nsize; j++){ q[nsize-j]=p[j]; }
 	polytexform2(q,nsize,lcm);
 }
 
 void polytexformint(const rat::vector<rational>& p, const int nsize)
 {
 	for (int i=0; i<=nsize; i++){
 		double a=p[i];
 		rational x=fabs(p[i]); 
 		longint ap = x.denominator();
 		if(ap != longint::ONE){
 			std::cout << " polytexformint ERROR  p[i] not integer, value=" << a << std::endl;
 		}
 		ap = x.numerator();
 		if( p[i] > rational::ZERO ){
 			if( i == nsize ){
 				if(a>pow(2,52)){
 					std::cout << "+" << p[i] ;
 //					std::cout << "+" << ap;
 				}else{
 					std::cout << "+" << a ;
 				}
 			}else{
 				if(a>pow(2,52)){
 					std::cout << "+" << p[i] << "*x^" << nsize-i << " ";
 //					std::cout << "+" << ap << "*x^" << nsize-i << " ";
 				}else{
 					std::cout << "+" << a << "*x^" << nsize-i << " ";
 				}
 			}
 		}else{
 			if( i == nsize ){
 				if(-a>pow(2,52)){
 					std::cout << p[i] ;
 //					std::cout << "-" << ap;
 				}else{
 					std::cout << a;
 				}
 			}else{
 				if(-a>pow(2,52)){
 					std::cout << p[i] << "*x^" << nsize-i << " " ;
 //					std::cout << "-" << ap << "*x^" << nsize-i << " " ;
 				}else{
 					std::cout << a << "*x^" << nsize-i << " " ;
 				}
 			}
 		}
 	}
 	std::cout << std::endl;
 }
 
 void polytexformintfmt(const rat::vector<rational>& p, const int nsize)
 {
 	for (int i=0; i<=nsize; i++){
 		if( p[i] > rational::ZERO ){
 			std::cout << "+" << p[i].format(30,0) << "*x^{" << nsize-i << "} " << std::endl;
 		}else{
			double pdble=-p[i]; if(log10(pdble)>30){  //  2016feb21
 				std::cout << "-" << p[i].format(30,0) << "*x^{" << nsize-i << "} " << std::endl;
			}else{
 				std::cout <<  p[i].format(30,0) << "*x^{" << nsize-i << "} " << std::endl;
			}
 		}
 	}
 	std::cout << std::endl;
 }
 void polytexformintr(const rat::vector<rational>& p, const int nsize)
 {
 	rat::vector<rational> q(nsize+1);
 	for (int j=0; j<=nsize; j++){ q[nsize-j]=p[j]; }
 //	polytexformint(q,nsize);
 	polytexformintfmt(q,nsize);
 }

 int askinty(const double t, const double epsint)
 {
 	int rtnval=0;
 	if(fabs(floor(t)-t) < epsint) rtnval=1;
 	if(fabs(ceil(t)-t)  < epsint) rtnval=1;
 	return rtnval;
 }
 
 int askinty(const double t, const double epsint, rational& vrat)
 {
 	double u;
 	int rtnval=0;
 
 	if(fabs(floor(t)-t) < epsint){
 		u=floor(t); vrat=Rdset(&u); rtnval=1;
 	}
 	if(fabs(ceil(t)-t) < epsint){
 		u=ceil(t); vrat=Rdset(&u); rtnval=1;
 	}
 	return rtnval;
 }
 
 int askinty(const rational& t, const double epsint, rational& vrat)
 {
 	rational x;
 	longint xd,xn,xq,xr,xh;
 	int rtnval=0;
 
 	rational t1=t.floor()-t;
 	rational t2=t1.abs();
 	if((double)t2 < epsint) rtnval=1;
 
 	t1=t.ceil()-t;
 	t2=t1.abs();
 	if((double)t2 < epsint) rtnval=1;
 
 	if(rtnval==1){
 		if(t < rational::ZERO){
 			x=-t;
 		}else{
 			x=t;
 		}
 		xd = x.denominator();
 		xh = longint::ldivide(xd,longint::TWO,&xr);
 		xn = x.numerator();
 		xq = longint::ldivide(xn,xd,&xr);
 		if( xr > xh) xq=xq+longint::ONE;
 		vrat=RRset(xq,longint::ONE);
 		if(t < rational::ZERO) vrat=-vrat;
 	}
 	return rtnval;
 }
 
 double vietaterm(const double e[], const int n, const int r)
 {
 	int ith[r+1];
 	for(int i=1; i<=r;i++){ith[i]=i;}
 	ith[r]=ith[r]-1;
 
 	double t=0;
 	long long nn=comb(n,r);
 	for(long long i=1; i<=nn; i++){
 		nxtcmb(n,r,ith);
 		double s=1;
 		for(int j=1; j<=r; j++) s=s*e[ith[j]];
 		t=t+s;
 	}
 	if(r%2==1) t=-t;
 	return t;
 }
 
 rational vietaterm(const rat::vector<rational>& e, const int n, const int r)
 {
 	int ith[r+1];
 	for(int i=1; i<=r;i++){ith[i]=i;}
 	ith[r]=ith[r]-1;
 
 	rational t=0;
 	long long nn=comb(n,r);
 	for(long long i=1; i<=nn; i++){
 		nxtcmb(n,r,ith);
 		rational s=rational::ONE;
 		for(int j=1; j<=r; j++) s=s*e[ith[j]];
 		t=t+s;
 	}
 	if(r%2==1) t=-t;
 	return t;
 }
 
 int vietaterm(const rat::vector<rational>& ea, const rat::vector<rational>& eb, const int n, const int r, rational& ta, rational& tb)
 {
 	rational sa,sb,ua,ub;
 	int ith[r+1];
 	for(int i=1; i<=r;i++){ith[i]=i;}
 	ith[r]=ith[r]-1;
 
 	ta=0; tb=0;
 	long long nn=comb(n,r);
 	for(long long i=1; i<=nn; i++){
 		nxtcmb(n,r,ith);
 		sa=rational::ONE; sb=rational::ONE;
 		for(int j=1; j<=r; j++) {
 			if(ea[ith[j]].s * eb[ith[j]].s < 0){
 				std::cout << "rational.vietaterm ERROR STOP" << std::endl;
 				exit(3);
 			}
 			intmul(sa,sb,ea[ith[j]],eb[ith[j]],sa,sb);
 		}
 		ta=ta+sa; tb=tb+sb;
 	}
 	if(r%2==1) { rational t=ta; ta=-tb; tb=-t; }
 	return 1;
 }
 
 int vietaterm(const rat::vector<rational>& ea, const rat::vector<rational>& eb, const int n, const int r, rational& ta, rational& tb, const rat::vector<rational>& spa, const rat::vector<rational>& spb, rat::vector<rational>& ssa, rat::vector<rational>& ssb)
 {
 	rational sa,sb;
 	int ith[r+1], kth[r+1];
 	for(int i=1; i<=r;i++) ith[i]=i; 
 	ith[r]--;
 	for(int i=1; i<=r;i++) kth[i]=ith[i]; 
 
 	ta=0; tb=0;
 	long long nn=comb(n,r);
 	int k=1, l=1;
 	for(long long i=1; i<=nn; i++){
 		nxtcmb(n,r,ith);
 		if(cmpary(ith,kth,r-1) != 1) l++;
 		if(r == 1){
 			sa=ea[ith[1]]; sb=eb[ith[1]];
 		}else if( r == 2){
 			intmul(ea[ith[1]],eb[ith[1]],ea[ith[2]],eb[ith[2]],sa,sb);
 		}else{
 			intmul(spa[l],spb[l],ea[ith[r]],eb[ith[r]],sa,sb);
 		}
 		if(r > 1 && r < n){ 
 			if(ith[r] != n){
 				ssa[k]=sa; ssb[k]=sb; k++;
 			}
 		}
 		ta=ta+sa; tb=tb+sb;
 		for(int i=1; i<=r;i++) kth[i]=ith[i];
 	}
 	if(r%2==1) { rational t=ta; ta=-tb; tb=-t; }
 	return k-1;
 }
 
 int cmpary(const int a[], const int b[], const int n)
 {
 	int rtnval=1;
 	for(int i=1; i<=n; i++){
 		if(a[i] != b[i]){
 			rtnval=0;
 			break;
 		}
 	}
 	return rtnval;
 }

 void intmul(const rational& xa, const rational& xb, const rational& ya, const rational& yb, rational& za, rational& zb)
 {
 	rational ua,ub;
 	int xsgn, ysgn;
 	if(xa.s != xb.s){
 		std::cout << "intmul x sign ERROR STOP" << std::endl;
 		exit(3);
 	}
 	if(ya.s != yb.s){
 		std::cout << "intmul y sign ERROR STOP" << std::endl;
 		exit(3);
 	}
 	if(xa > xb){
 		std::cout << "intmul xa larger than xb ERROR STOP" << std::endl;
 		exit(3);
 	}
 	if(ya > yb){
 		std::cout << "intmul ya larger than yb ERROR STOP" << std::endl;
 		exit(3);
 	}
 
 	xsgn=0;
 	if(xa > rational::ZERO){
 		xsgn=1;
 	}else if(xa < rational::ZERO){
 		xsgn=-1;
 	}
 	if(xsgn == 0){
 		if(xb > rational::ZERO) xsgn=1;
 	}         // i.e., xsgn==0 means (Xa,Xb)=(0,0)
 
 	ysgn=0;
 	if(ya > rational::ZERO){
 		ysgn=1;
 	}else if(ya < rational::ZERO){
 		ysgn=-1;
 	}
 	if(ysgn == 0){
 		if(yb > rational::ZERO) ysgn=1;
 	}         // i.e., ysgn==0 means (Ya,Yb)=(0,0)
 
 	if(xsgn*ysgn > 0){  // result +
 		ua=xa*ya; ub=xb*yb;
 		if( xsgn > 0){
 			za=ua; zb=ub;
 		}else{
 			za=ub; zb=ua;
 		}
 	}else if(xsgn*ysgn < 0){ //  result -
 		ub=xb*ya; ua=xa*yb;
 		if( xsgn > 0){
 			za=ub; zb=ua;
 		}else{
 			za=ua; zb=ub;
 		}
 	}else if(xsgn*ysgn == 0){ //  result 0
 		za=rational::ZERO; zb=rational::ZERO;
 	}
 }
 
 void nxtcmb(const int n, const int r, int ith[])
 {
 	int i,j;
 	if(ith[r]==n){
 		for(i=r-1; i>0;i--){    // search position to add
 			if(ith[i]<=n-(r-i)-1){
 				ith[i]++;
 				for(j=i+1; j<=r;j++) ith[j]=ith[i]+j-i;
 				break;
 			}
 		}
 	}else{
 		ith[r]++;
 	}
 }
 
 void nxtcmb(const int n, const int r, int ith[], int chnj)
 {
 	int i,j;
	chnj=r;
 	if(ith[r]==n){
 		for(i=r-1; i>0;i--){    // search position to add
 			if(ith[i]<=n-(r-i)-1){
 				ith[i]++;
				chnj=i; // this is where chenged position found
 				for(j=i+1; j<=r;j++) ith[j]=ith[i]+j-i;
 				break;
 			}
 		}
 	}else{
 		ith[r]++;
 	}
 }
 
 long long comb(const int n, const int r)
 {
   /**********************************
 	long long t;
 	t=(long long)n;
 	for(int i=1; i<r-1;i++){
 		t=t*((long long)(n-i));
 		t=t/((long long)(i+1));
 	}
 	return t;
   **********************************/
 	int i;
 	longint t("1"), s("1"),x,y;
 	uint32_t ni;
 	long long result;
 	if(n>61){
 		std::cout << " function comb STOP due to n>61,   n=" << n << std::endl;
 		exit(1);
 	}
 
 	for(i=0; i<r;i++){
 		ni=n-i;
 		x=ni;      //  cast int to longint
 		t=t*x;
 	}
 	for(i=1; i<=r;i++){
 		ni=i;
 		if(ni != 0){
 			x=ni;
 			s=s*x;
 		}
 	}
 	x=longint::ldivide(t,s,&y);
 	result=x;
 	return result;
 }

 int bisectrf(const rat::vector<rational>& p, const int n, const double tol, const int maxit, rational& a, rational& fa, rational& b, rational& fb, rational& c)
 {
 	rational fc, fdc, fddc, csave, fcsave;
 	int k, it=0, rtnval;
 
 	std::cout << " bisectrf start tol=" << tol << " maxit=" << maxit << " b-a=" << (double)(b-a) << std::endl;
 	fa=Horner(n,p,a); fb=Horner(n,p,b);
 	while( it < maxit){
 		it++; totalit++;
 		if(fa*fb > rational::ZERO){
 			std::cout << " bisectrf error  a=" << std::setprecision(16) << (double)a << " b=" << (double)b << " fa=" << (double)fa <<  " fb=" << (double)fb << " STOP" <<  std::endl;
 			exit(3);
 		}
		if(b-a == rational::ZERO){
 			std::cout << " bisectrf(rational) a==b then break" <<  std::endl;
 			rtnval=0; break;
		}
 		if(it >= maxit){
 			std::cout << " bisectrf MAXIT reached it=" << it << std::endl;
 			rtnval=-it; break;
 		}
 		rational d = a-(fa*(b-a))/(fb-fa); // regula falsa estimates d for solution
		rational cab=min(d-a,b-d);         // smaller interval cab = min(d-a,b-d)
		if(cab*rational::TEN > b-a){       // select bisect or regula falsa
			c=(a+b)/rational::TWO;     // use mid-point, i.e., bisection scheme
		}else{
			int nprec=5-log2((double)(cab))/10;
			if(nprec<0) nprec=1;
			interval d2=roundrat(d,nprec); // round d to interval having power of 2 in their denominators
			rational dl=d2.lower(); rational du=d2.upper(); rational dm=(dl+du)/rational::TWO;
			rational ori, fo, h;
			if(dm-a < b-dm){               // d is closer to a
				ori=a; fo=fa; h=du-a;  // use upper() 
				if((h.rational::abs())*rational::MEGA < b-a){
					h=h*rational::KIL;
				}
			}else{                         // d is closer to b
				ori=b; fo=fb; h=dl-b;  // use lower() 
				if((h.rational::abs())*rational::MEGA < b-a){
					h=h*rational::KIL;
				}
			}
 			std::cout << " Regula falsa h=" << (double)h  << " abs(h)=" << (double)(h.rational::abs()) << " interval=" << (double)(b-a) << std::endl;
			c=ori+h;
			double bound=log2((double)((b-a)/h.rational::abs()));
			int ntimes=(int)bound;
			int flag=0;
			for(k=0; k<ntimes; ++k){
				fc=Horner(n,p,c);
				if(fc*fo < rational::ZERO){
					flag=1; break;
				}
				h=h*rational::TWO;
				c=ori+h;
				if(c<a || c>b){
 					std::cout << " regula falsa c<a || c>b ERROR STOP k=" << k << " ori=" << (double)ori << " h=" << (double)h << std::endl;
					exit(3);
				}
			}
			if(flag==0){
				c=(a+b)/rational::TWO;
 				std::cout << " regula falsa exceeds bound use mid-point in stead" << std::endl;
			}
		}
		if(b-a<rational::ZERO){
 			std::cout << " regula falsa ERROR b<a " << (double)(b-a) <<  std::endl;
		}
	//  ***************************************
 		Horner3(n,p,c,fc,fdc,fddc);
 		if(fc == rational::ZERO){
 			a=c; fa=fc; b=c; fb=fc;
 			rtnval=0; break;
 		}
 		if(fa*fc > rational::ZERO){
 			a=c; fa=fc;
 		}else{
 			b=c; fb=fc;
 		}
 		if(it%50==0) std::cout << " bisectrf it=" << it <<  " b-a=" << (double)(b-a) << std::endl;
 		if((double)(b-a) < tol){ 
 			rtnval=it; break;
 		}
 	}
 	return rtnval;
 }

 int bisect(const rat::vector<rational>& p, const int n, const double tol, const int maxit, rational& a, rational& fa, rational& b, rational& fb, rational& c)
 {
 	rational fc, fdc, fddc;
 	int it=0, rtnval;
 
 	fa=Horner(n,p,a); fb=Horner(n,p,b);
 	while( it < maxit){
 		it++; totalit++;
 		if(fa*fb > rational::ZERO){
 			std::cout << " bisect error  a=" << std::setprecision(16) << (double)a << " b=" << (double)b << " fa=" << (double)fa <<  " fb=" << (double)fb << " STOP" <<  std::endl;
 			exit(3);
 		}
 		if(it >= maxit){
 			std::cout << " bisect MAXIT reached it=" << it << std::endl;
 			rtnval=-it; break;
 		}
 		c = (a + b) / rational::TWO;
 		Horner3(n,p,c,fc,fdc,fddc);
 		if(fc == rational::ZERO){
// 			std::cout << " bisect converged it=" << it << " fc==rational::ZERO" << std::endl;
 			a=c; fa=fc; b=c; fb=fc;
 			rtnval=0; break;
 		}
 		if(fa*fc > rational::ZERO){
 			a=c; fa=fc;
 		}else{
 			b=c; fb=fc;
 		}
 		if(it%50==0) std::cout << " bisect it=" << it <<  " b-a=" << (double)(b-a) << std::endl;
 		if((double)(b-a) < tol){ 
 			rtnval=it; break;
 		}
 	}
 	return rtnval;
 }
 
 #ifdef BISECTSHIFT
 rational bestappfrac(const rational& c,const double tol)
 {
 	rat::vector<rational> a(1002);
 	rational p,q,x,y,z,t;
 	int i, k, n, m;
 	n=-(int)log10(tol)+10;
 	x=c;
 	p=x.ceil();
 	a[0]=p;
 	for(i=1;i<=n; i++){
 		y=x-p;
 		if(y == rational::ZERO) break;
 		x=rational::ONE/y;
 		p=x.ceil();
 		a[i]=p;
 	}
 	m=i-1;
 	p=rational::ONE;
 	q=a[m];
 	for(i=m-1; i>=1; i--){
 		t=p+q*a[i];
 		p=q;
 		q=t;
 	}
 	if(m==0){
 		z=a[0];
 	}else{
 		z=a[0]+p/q;
 	}
 	return z;
 }
 #endif
 
 rational Horner(const int n, const rat::vector<rational>& coef, const rational& x)
 {
 	rational r = coef[0];
 	for (int i=1; i <= n; ++i) {
 		r = r*x + coef[i];
 	}
 	return r;
 }
 
 void Horner3(const int n, const rat::vector<rational>& coef, const rational& x, rational& r, rational& s, rational& t) {
 	if(n >= 2){
 		r = coef[0]; s = coef[0]; t = coef[0];
 		for (int i=1; i < n-1; ++i) {
 			r = r*x + coef[i]; s = s*x + r; t = t*x + s;
 		}
 		r = r*x + coef[n-1]; s = s*x + r; 
 		r = r*x + coef[n]; 
 		t = t*rational::TWO;
 	}else if(n ==1){
 		r = coef[0]*x + coef[1];
 		s = coef[1];
 		t = rational::ZERO;
 	}else if(n ==0){
 		r = coef[0];
 		s = rational::ZERO;
 		t = rational::ZERO;
 	}
 }

void Horner(const int n, const rat::vector<rational>& coef, const interval& x, rational& r, rational& s)
{
	r = coef[0]; s = coef[0];
	for (int i=1; i <= n; ++i) {
		r = r*x.lower() + coef[i];
		s = s*x.upper() + coef[i];
	}
}

int bisectrf(const rat::vector<rational>& p, const int n, const double tol, const int maxit, interval& ab, rational& fa, rational& fb, rational& c)
{
	rational fc, fdc, fddc, csave, fcsave;
	int k, it=0, rtnval;
	rational a=ab.lower(); rational b=ab.upper();

	int mprec=5-log2(tol)/10;
	if(mprec<0) mprec=1;
 	std::cout << " bisectrf(interval) start tol=" << tol << " mprec=" << mprec << " maxit=" << maxit << " b-a=" << (double)(b-a) << std::endl;
	Horner(n,p,ab,fa,fb);
 	while( it < maxit){
 		it++; totalit++;
 		if(fa*fb > rational::ZERO){
 			std::cout << " bisectrf(interval) error  a=" << std::setprecision(16) << (double)a << " b=" << (double)b << " fa=" << (double)fa <<  " fb=" << (double)fb << " STOP" <<  std::endl;
 			exit(3);
 		}
		if(b-a == rational::ZERO){
 			std::cout << " bisectrf(interval) a==b then break" <<  std::endl;
 			rtnval=0; break;
		}
 		if(it >= maxit){
 			std::cout << " bisectrf(interval) MAXIT reached it=" << it << std::endl;
 			rtnval=-it; break;
 		}
 		rational d = a-(fa*(b-a))/(fb-fa); // regula falsa estimates d for solution
		rational cab=min(d-a,b-d);         // smaller interval cab = min(d-a,b-d)
		if(cab*rational::TEN > b-a){       // select bisect or regula falsa
			c=(a+b)/rational::TWO;     // use mid-point, i.e., bisection scheme
		}else{
			int nprec=5-log2((double)(cab))/10;
			if(nprec<0) nprec=1;
			interval d2=roundrat(d,nprec); // round d to interval having power of 2 in their denominators
			rational dl=d2.lower(); rational du=d2.upper(); rational dm=(dl+du)/rational::TWO;
			rational ori, fo;
			rational h;
			if(dm-a < b-dm){              // d is closer to a
				ori=a; fo=fa; h=du-a; // use upper() 
				if((h.rational::abs())*rational::MEGA < b-a){
					h=h*rational::KIL;
				}
			}else{                        // d is closer to b
				ori=b; fo=fb; h=dl-b; // use lower() 
				if((h.rational::abs())*rational::MEGA < b-a){
					h=h*rational::KIL;
				}
			}
 			std::cout << " Regula falsa h=" << (double)h  << " abs(h)=" << (double)(h.rational::abs()) << " abs(h)*rational::TEN=" << (double)(h.rational::abs())*rational::TEN << " interval=" << (double)(b-a) << std::endl;
			c=ori+h;
			double bound=log2((double)((b-a)/h.rational::abs()));
			int ntimes=(int)bound;
			int flag=0;
			for(k=0; k<ntimes; ++k){
				fc=Horner(n,p,c);
				if(fc*fo < rational::ZERO){
					flag=1; break;
				}
				csave=c; fcsave=fc;                  ///////////////////////
				h=h*rational::TWO;
				c=ori+h;
				if(c<a || c>b){
 					std::cout << " regula falsa c<a || c>b ERROR STOP k=" << k << " ori=" << (double)ori << " h=" << (double)h << std::endl;
					exit(3);
				}
			}
			if(flag==0){
				c=(a+b)/rational::TWO;
 				std::cout << " regula falsa exceeds bound use mid-point in stead" << std::endl;
			}
		}
		if(b-a<rational::ZERO){
 			std::cout << " regula falsa ERROR b<a " << (double)(b-a) <<  std::endl;
		}
	//  ***************************************
 		Horner3(n,p,c,fc,fdc,fddc);
 		if(fc == rational::ZERO){
 			std::cout << " bisectrf(interval) converged it=" << it << " fc=rational::ZERO" << std::endl;
 			a=c; fa=fc; b=c; fb=fc;
 			rtnval=it; break; 
 		}
 		if(fa*fc > rational::ZERO){
 			a=c; fa=fc;
 		}else{
 			b=c; fb=fc;
 		}
 		if((double)(b-a) < tol){ 
 			rtnval=it; break;
 		}
 	}
	ab=interval(a,b);
 	return rtnval;
 }

int bisect(const rat::vector<rational>& p, const int n, const double tol, const int maxit, interval& ab, rational& fa, rational& fb, rational& c)
{
	rational a, b, fc, fdc, fddc;
	int it=0, rtnval;

	Horner(n,p,ab,fa,fb);
	a=ab.lower(); b=ab.upper();   //  switch from interval to two rational
	while( it < maxit){
		it++; totalit++;
		if(fa*fb > rational::ZERO){
			std::cout << " bisect(interval) error  a=" << std::setprecision(16) << (double)a << " b=" << (double)b << " fa=" << (double)fa <<  " fb=" << (double)fb << " STOP" <<  std::endl;
			exit(3);
		}
		if(b-a == rational::ZERO){
 			std::cout << " bisect(interval) a==b then break" <<  std::endl;
 			rtnval=0; break;
		}
		if(it >= maxit){
			std::cout << " bisect(interval) MAXIT reached it=" << it << std::endl;
			rtnval=-it; break;
		}
		c = (a + b) / rational::TWO;
		Horner3(n,p,c,fc,fdc,fddc);
		if(fc == rational::ZERO){
			a=c; fa=fc; b=c; fb=fc;
			rtnval=0; break;
		}
		if(fa*fc > rational::ZERO){
			a=c; fa=fc;
		}else{
			b=c; fb=fc;
		}
		if(it%50==0) std::cout << " bisect(interval) it=" << it <<  " b-a=" << (double)(b-a) << std::endl;
		if((double)(b-a) < tol){ 
			std::cout << " bisect(interval) converged it=" << it << " b-a=" << std::setprecision(16) << (double)(b-a) << std::endl;
			rtnval=it; break;
		}
	}
	ab=interval(a,b);
	return rtnval;
}


void GenRand(rat::matrix<rational>& a, const int n, const int r, long long& iseed)
{
	rational drand;
	for (int i=0; i < n; ++i){
		for (int j=0; j < r; ++j){
			MyRND(iseed,drand);   // rational class routine
			a[i][j] = drand;
		}
	}
	for (int j=r; j < n; ++j){              // make column j
		for (int i=0; i < n; ++i){      // lineary dependent
			a[i][j]=rational::ZERO; // from previous columns
			for (int k=0; k < n; ++k){
				a[i][j]=a[i][j]+a[i][k];
			}
		}
	}
}

void GenMat(rat::matrix<rational>& a, const int m, const int n, const int r, long long& iseed)
{
	rational drand;
	GenRand(a,n,r,iseed);       // set n x n submatrix (rank r)
	for (int j=0; j < m; ++j){  // column j
		int i1;
		if(j < n){ 
			i1=n;
		}else{
			i1=0;
		}
		for (int i=i1; i < m; ++i){   // insert randum number
			MyRND(iseed,drand);   // rational class routine
			a[i][j] = drand;
		}
	}
}
 
 void SetRand2(rat::matrix<rational>& a, const int n, long long& iseed)
 {          // numerator and denominator are independent randum number.
 	rational drandn, drandd;
 	for (int i=0; i < n; ++i) {
 		for (int j=0; j <= i; ++j) {
 			MyRND(iseed,drandn);
 			MyRND(iseed,drandd);
 			a[i][j] = drandn / drandd;
 			a[j][i] = a[i][j];
 		}
 	}
 }

 void SetRand(rat::matrix<rational>& a, const int n, long long& iseed)
 {
 	rational drand;
 	for (int i=0; i < n; ++i) {
 		for (int j=0; j <= i; ++j) {
 			MyRND(iseed,drand);
 			a[i][j] = drand;
 			a[j][i] = a[i][j];
 		}
 	}
 }
 
 void MyRND(long long& iseed, rational& drand)
 {
 	MyIRND(iseed);
 	longint n = (uint64_t) iseed;
 	longint d = (uint64_t) 2147483647L;
 	drand.set(n,d);
 }
 
 void MyIRND(long long& iseed)
 {
 	long long k = iseed*16807;
 	iseed = k % 2147483647;
 }
 
 double urand( void )
 {
 	static int x=1;
 /******************************************************************************/
 //	int a=1103515245;
 //	int b=12345;
 	int a=16807;
 	int b=0;
 	int c=2147483647;                     /*  2^31-1  is a prime number */
 /*        1. b and c should be relatively prime.                            */
 /*        2. a-1 should be multiple to all prime numbers that divide-up c.  */
 /*        3. if c is multiple of four, then a-1 should be multiple of four. */
 /*              reference p.2 of Prime numbers by Fushimi Masanori          */
 /******************************************************************************/
 	x = (a*x + b)&c;
 	return ((double)x) / ((double)c);
 }
 
 void FloatUrandR(rat::matrix<rational>& a, const int m, const int n)
 {
 	double aij;
 	for (int i=0; i < m; ++i) {
 		for (int j=0; j < n; ++j) {
 			aij= urand()-0.5;
 			a[i][j] = Rdset(&aij);
 		}
 	}
 }
 
 void SetFrank(rat::matrix<double>& a, const int n)
 {
 	for (int i=0; i < n; ++i) {
 		for (int j=0; j < n; ++j) {
 			a[i][j] = (n - ((i+1)>(j+1)?(i+1):(j+1))+1);  // n-max(i,j)+1
 		}
 	}
 }
 
 void SetFrank(rat::matrix<rational>& a, const int n)
 {
 	for (int i=0; i < n; ++i) {
 		for (int j=0; j < n; ++j) {
 			a[i][j] = (n - ((i+1)>(j+1)?(i+1):(j+1))+1);  // n-max(i,j)+1
 		}
 	}
 }
 
 void SetHilbert(rat::matrix<double>& a, const int n)
 {
 	double den;
 	for (int i=0; i < n; ++i) {
 		for (int j=0; j < n; ++j) {
 			den = (double)((i+1) + (j+1) -1);
 			a[i][j] = (double)1 / den;  // 1/(i+j-1)
 		}
 	}
 }
 
 void SetHilbert(rat::matrix<rational>& a, const int n)
 {
 	rational num, den;
 	num = 1;
 	for (int i=0; i < n; ++i) {
 		for (int j=0; j < n; ++j) {
 			den = ((i+1) + (j+1) -1);
 			a[i][j] = num / den;  // 1/(i+j-1)
 		}
 	}
 }
 
 void SetFtherm(rat::matrix<rational>& a, const int m, const int cont) {
 	int i, j;
 	double adiag = 0.4;                   /*  A diagonal    2012 Dec 13 */
 	double ediag = 0.4000000000000001;    /*  A diagonal including error  */
 	double offdg = -0.1;
 
 //	for (i=0; i < (int)a.nrows(); ++i) {
 	for (i=0; i < (int)a.rows(); ++i) {
 //		for (j=0; j < (int)a.ncols(); ++j) {
 		for (j=0; j < (int)a.columns(); ++j) {
 			a[i][j] = rational::ZERO;
 		}
 	}
 	for (i=0; i < m; ++i) {
 		if (i >= 1) a[i][i-1] = Rdset(& offdg);
 		a[i][i] = Rdset(& adiag);
 		if (((i+1) % m) != 0) a[i][i+1] = Rdset(& offdg);
 		a[i][i+m] = Rdset(& offdg);
 	}
 	for (i=m; i < (m*(m-1)); ++i) {
 		a[i][i-m] = Rdset(& offdg);
 		if (((i+1) % m) != 1) a[i][i-1] = Rdset(& offdg);
 		a[i][i] = Rdset(& adiag);
 		if (((i+1) % m) != 0) a[i][i+1] = Rdset(& offdg);
 		a[i][i+m] = Rdset(& offdg);
 	}
 	for (i=m*(m-1); i < m*m; ++i) {
 		a[i][i-m] = Rdset(& offdg);
 		if (((i+1) % m) != 1) a[i][i-1] = Rdset(& offdg);
 		a[i][i] = Rdset(& adiag);
 		if (((i+1) % m) != 0) a[i][i+1] = Rdset(& offdg);
 	}
 	if(cont == 1) a[0][0] = Rdset(& ediag);
 }
 
 void SetFtherm(rat::matrix<double>& a, const int m) {
 	int i, j;
 	double adiag = 4;
 	double offdg = -1;
 
 	for (i=0; i < m*m; ++i) {
 		for (j=0; j < m*m; ++j) {
 			a[i][j] = 0;
 		}
 	}
 	for (i=0; i < m; ++i) {
 		if (i >= 1) a[i][i-1] = offdg;
 		a[i][i] = adiag;
 		if (((i+1) % m) != 0) a[i][i+1] = offdg;
 		a[i][i+m] = offdg;
 	}
 	for (i=m; i < (m*(m-1)); ++i) {
 		a[i][i-m] = offdg;
 		if (((i+1) % m) != 1) a[i][i-1] = offdg;
 		a[i][i] = adiag;
 		if (((i+1) % m) != 0) a[i][i+1] = offdg;
 		a[i][i+m] = offdg;
 	}
 	for (i=m*(m-1); i < m*m; ++i) {
 		a[i][i-m] = offdg;
 		if (((i+1) % m) != 1) a[i][i-1] = offdg;
 		a[i][i] = adiag;
 		if (((i+1) % m) != 0) a[i][i+1] = offdg;
 	}
 }
 
 void SetGLmat(rat::matrix<double>& a, const int m)
 {
 	int i, j, n;
 	n=(m-2)*(m-2)+4*(m-2);
 	std::cout << "genGLmat generates Graph Laplacian matrix n=" << n << std::endl;
 	for (i=0; i < n; ++i) {
 		for (j=0; j < n; ++j) a[i][j] = 0;
 	}
 	for (i=0; i <= m-3; ++i) { a[i][i] = 1; a[i][i+m-1] = -1; }
 	for (j=0; j < m-2; ++j) {
 		for (i=0; i <= m-1; ++i) {
 			n=m-2+j*m+i+1;
 			if(i==0 || i==m-1){
 				a[n-1][n-1]=1;
 				if(i<m-1) a[n-1][n]=-1;
 			}else{
 				a[n-1][n-1]=4; a[n-1][n]=-1;
 				if(j<m-3){
 					a[n-1][n+m-1]=-1;
 				}else{
 					if(i<m-1) a[n-1][n+m-2]=-1;
 				}
 			} // if(i==0 || i==m){
 		}        //  for (i=0; i < m; ++i) {
 	}    //              for (j=0; j < m-1; ++j) {
 	for (i=m-2+m*(m-2); i <= m-2+m*(m-2)+m-2; ++i) a[i-1][i-1]=1;
 	n=(m-2)*(m-2)+4*(m-2);
 	for (j=0; j <= n-2; ++j) {
 		for (i=j+1; i < n; ++i) a[i][j]=a[j][i];
 	}
 }

int jacobev(rat::matrix<double>& A, rat::matrix<double>& V,double tol,int n,int maxit){
   double t=0, c=0, s=0, akk=0, all=0, akj=0, alj=0, S;
   int i, j, k, l, m, I, J;
   for (j=0; j<n; j++){               // set I for eigenvectors
      for (i=0; i<n; i++) V[i][j]=0;
      V[j][j]=1;
   }

   for (m=0; m<maxit; m++){
     S=0.0;
     for (j=0; j<n; j++){
       for (i=j+1; i<n; i++){
         S=S+fabs(A[i][j]); 
       }
     }
     if (S<tol) // convergence check
     return m;

     for (J=0; J<n; J++){
       for (I=J+1; I<n; I++){
         k=I;
         l=J; 

         if (A[k][k]==A[l][l])
            t=PI/4.0;
         else
            t=atan(2.*A[k][l]/(A[k][k]-A[l][l]))/2.0;
         c=cos(t); s=sin(t);
         akk=A[k][k]*c*c+A[l][l]*s*s+2.0*A[k][l]*c*s;
         all=A[k][k]*s*s+A[l][l]*c*c-2.0*A[k][l]*c*s;
         A[k][k]=akk; A[k][l]=0.0; A[l][k]=0.0; A[l][l]=all;
         for (j=0; j<n; j++){
           if (j!=k && j!=l){
             akj=A[k][j]*c+A[l][j]*s;
             alj=-s*A[k][j]+c*A[l][j];
             A[j][l]=alj; A[l][j]=alj; A[k][j]=akj; A[j][k]=akj;
           }
         }
         for (j=0; j<n; j++){        // accumulate transformations
           akj=V[j][k]*c+V[j][l]*s;  //   for eigenvectors
           alj=-s*V[j][k]+c*V[j][l];
           V[j][k]=akj; V[j][l]=alj;
         }
       }
     }
   }
   if (m>maxit)
     std::cout << "Not converged\n";
   return -1;
}

void bsort(rat::vector<double>& x, int n, int * ind){
    int i, j, k;
    double temp;

    for (i = 0; i < n; i++) {ind[i]=i;}

    for (i = 0; i < n - 1; i++) {
        for (j = n - 1; j > i; j--) {
            if (x[j - 1] > x[j]) {  /* O̗vf̕傫 */
                temp = x[j]; x[j] = x[j - 1]; x[j - 1]= temp;
                k  = ind[j]; ind[j]=ind[j-1]; ind[j - 1] = k;
            }
        }	
    }
}

void bsort(rat::vector<double>& x, int n)
{
    int i, j;
    double temp;

    for (i = 0; i < n - 1; i++) {
        for (j = n - 1; j > i; j--) {
            if (x[j - 1] > x[j]) { /* if the former is greater than the latter*/
                temp = x[j];       /* swap */
                x[j] = x[j - 1];
                x[j - 1]= temp;
            }
        }	
    }
}

void displayrat(const rational& tmp)
{
	longint tn=tmp.rational::numerator();
	longint td=tmp.rational::denominator();
	std::cout << "tmp=" << (double)tmp << " tmp=" << tmp << std::endl;
	std::cout << "num=" << tn.str() << std::endl;
	std::cout << "den=" << td.str() << std::endl;
}

interval roundrat(const rational& x, const int n)
{
//  x = xn / xd \fallingdotseq y / rt = ( xl , xu )
//          where   rt = 1024 ** n
//     return (xl , xu)
//
	rational  xl, xu, y, rt=rational::ONE;
	for(int i=0; i<abs(n); i++){
		rt = rt * rational::KIL;
//		std::cout << "i=" << i << " rt=" << rt << std::endl;
	}
	longint xn=x.numerator(); longint xd=x.denominator();
	rational xnr(xn,longint::ONE); rational xdr(xd,longint::ONE);
	if(n > 0){
		y=rt*xnr/xdr;
	}else{
		y=xnr/(rt*xdr);
	}
//	std::cout << " roundrat  y=" << (double)y << " y=" << y << " n=" << n << std::endl;
	////////////////////////////////////////////
	rational y0=y.floor(); rational y1=y.ceil();
	////////////////////////////////////////////
	if(n>=0){
		y0=y0/rt; y1=y1/rt;
		if(x>rational::ZERO){
			xl=y0; xu=y1;
		}else{
			xl=-y1; xu=-y0;
		}
	}else{
		y0=y0*rt; y1=y1*rt;
		if(x>rational::ZERO){
			xl=y0; xu=y1;
		}else{
			xl=-y1; xu=-y0;
		}
	}
//	std::cout << "displayrat xl=" << std::endl;
//	displayrat(xl);
//	std::cout << "displayrat xu=" << std::endl;
//	displayrat(xu);
//
	if(xl > x || x > xu){
		std::cout << "roundrat ERROR xl>x  OR xu<x " << std::endl;
		interval xdbg=interval(xl,xu);
		formatprn(xdbg);
		std::cout << "x=" << (double)x <<  std::endl;
		exit(3);
	}
	interval xint=interval(xl,xu);
	return xint;
}


interval roundrat2(const rational& x, const int n, const int m)
{
//  x = xn / xd \fallingdotseq y / rt = ( xl , xu )
//          where   rt = 1024 ** n ,   rt = 2 ** m
//     return (xl , xu)
//
	rational  xl, xu, y, rt=rational::ONE;
	for(int i=0; i<abs(n); i++) rt = rt * rational::KIL;
	for(int j=0; j<m; j++) rt = rt * rational::TWO;
	longint xn=x.numerator(); longint xd=x.denominator();
	rational xnr(xn,longint::ONE); rational xdr(xd,longint::ONE);
	if(n > 0){
		y=rt*xnr/xdr;
	}else{
		y=xnr/(rt*xdr);
	}
//	std::cout << " roundrat2  y=" << (double)y << " y=" << y << std::endl;

	rational y0=y.floor(); rational y1=y.ceil();
	if(n>=0){
		y0=y0/rt; y1=y1/rt;
		if(x>rational::ZERO){
			xl=y0; xu=y1;
		}else{
			xl=-y1; xu=-y0;
		}
	}else{
		y0=y0*rt; y1=y1*rt;
		if(x>rational::ZERO){
			xl=y0; xu=y1;
		}else{
			xl=-y1; xu=-y0;
		}
	}
//	std::cout << "displayrat xl=" << std::endl;
//	displayrat(xl);
//	std::cout << "displayrat xu=" << std::endl;
//	displayrat(xu);
//
	if(xl > x || x > xu){
		std::cout << "roundrat2 ERROR xl>x  OR xu<x " << std::endl;
		exit(3);
	}
	interval xint=interval(xl,xu);
	return xint;
}

int newton(const rat::vector<rational>& p, const int n, const int tol, const int maxit, rational& a, rational& fa, rational& b, rational& fb, rational& c)
 {
  	rational fc, fdc, fddc, csave, fcsave, da, db, fda,fdda,fdb,fddb,fd,fdd,fddd,d;
 	int it=0, rtnval;
 
// 	std::cout << " newton start tol=" << tol << " maxit=" << maxit << " b-a=" << (double)(b-a) << std::endl;
 
 	Horner3(n,p,a,fa,fda,fdda); Horner3(n,p,b,fb,fdb,fddb);
	if(fb==rational::ZERO){
		a=b; c=b; rtnval=1; return rtnval;
	}
	if(fb==rational::ZERO){
		b=a; c=a; rtnval=1; return rtnval;
	}
 
	interval ab(a,b);
	std::cout << " interval(a,b)=" << std::endl; formatprn(ab);
	int lz=(int)(-log10int(ab));  // lz (leading zeros) is where the difference begins in interval (a,b).
	int nprec=(int)((double)lz/0.30103)/10;   // convert tol to binary, then 1024=2^10
	std::cout << " first nprec=" << nprec << std::endl;
 	while( it < maxit){
//		std::cout << "It=" << it << " nprec=" << nprec << std::endl;;
 		if(fa*fb > rational::ZERO){
 			std::cout << " newton error  a=" << std::setprecision(16) << (double)a << " b=" << (double)b << " fa=" << (double)fa <<  " fb=" << (double)fb << " STOP" <<  std::endl;
 			exit(3);
 		}
 		it++; totalit++;
 		if(it >= maxit){
 			std::cout << " newton MAXIT reached it=" << it << std::endl;
 			rtnval=-it; break;
 		}
		rational dd=(a+b)/rational::TWO;   // use mid-point
 		Horner3(n,p,dd,fd,fdd,fddd);
 		d = dd-fd/fdd;                     // Newton-Raphson estimates d from mid-point
		rational cab=min(d-a,b-d);         // smaller interval cab = min(d-a,b-d)
		interval d2=roundrat(d,nprec);     // round d to interval having power of 2
		rational dl=d2.lower(); rational du=d2.upper(); rational dm=(dl+du)/rational::TWO;
		rational fdl=Horner(n,p,dl); rational fdu=Horner(n,p,du);
		if(fdl*fdu<rational::ZERO){        // Rough inclusion
			a=dl; b=du; fa=fdl; fb=fdu;
			std::cout << " Rough inclusion successful with nprec=" << nprec << ", ";
			while(true){
				nprec++;
				d2=roundrat(d,nprec); // round d to interval having power of 2 in their denominators
				dl=d2.lower(); du=d2.upper();
				fdl=Horner(n,p,dl); fdu=Horner(n,p,du);
				if(fdl*fdu<rational::ZERO){
					a=dl; b=du; fa=fdl; fb=fdu;
				}else{
					for(int m=1; m<10; m++){ //   step with * 2 
						d2=roundrat2(d,nprec-1,m); // round d 
						dl=d2.lower(); du=d2.upper();
						fdl=Horner(n,p,dl); fdu=Horner(n,p,du);
						if(fdl*fdu<rational::ZERO){
							a=dl; b=du; fa=fdl; fb=fdu;
						}else{
							std::cout << " improve accuracy stop with m=" << m << std::endl;
							break;
						}
					}
					break;
				}
			}
			interval ab(a,b); int lz=(int)(-log10int(ab)); 
 			if(lz > tol){ 
//				fdl=Horner(n,p,a); fdu=Horner(n,p,b);
				std::cout << " newton Converged it=" << it << " b-a=" << std::setprecision(16) << (double)(b-a) << std::endl;
//				std::cout << " newton Converged it=" << it << " b-a=" << std::setprecision(16) << (double)(b-a) << " f(a)=" << (double)fdl << " f(b)=" << (double)fdu <<std::endl;
 				rtnval=it; break;
 			}
		}else{
			std::cout << " Rough inclusion UNsuccessful with nprec=" << nprec << std::endl;
			nprec=nprec-1;
			rtnval=-nprec; break;      //////// 2016nov07
		}
		interval ab(a,b); int lz=(int)(-log10int(ab));
 		if(lz > tol){ 
//			fdl=Horner(n,p,a); fdu=Horner(n,p,b);
			std::cout << " Newton Converged it=" << it << " b-a=" << std::setprecision(16) << (double)(b-a) << " lz=" << lz << " tol=" << tol << std::endl;
//			std::cout << " Newton Converged it=" << it << " b-a=" << std::setprecision(16) << (double)(b-a) << " f(a)=" << (double)fdl << " f(b)=" << (double)fdu <<std::endl;
 			c=d; rtnval=it; break;
 		}
	}
 	return rtnval;
 }

int newton(const rat::vector<rational>& p, const int n, const int tol, const int maxit, interval& ab, rational& fa, rational& fb, rational& c)
 {
  	rational a, b;
  	rational fc, fdc, fddc, csave, fcsave, da, db, fda,fdda,fdb,fddb,fd,fdd,fddd,d;
 	int it=0, rtnval;
 
// 	std::cout << " newton start tol=" << tol << " maxit=" << maxit << " b-a=" << (double)(b-a) << std::endl;
 
// 	Horner3(n,p,a,fa,fda,fdda); Horner3(n,p,b,fb,fdb,fddb);
	Horner(n,p,ab,fa,fb);
	a=ab.lower(); b=ab.upper();   //  switch from interval to two rational numbers

	if(fb==rational::ZERO){
		a=b; c=b; return 1;
	}
	if(fb==rational::ZERO){
		b=a; c=a; return 1;
	}
 
//	interval ab(a,b);
	std::cout << " newton: interval(a,b)=" << std::endl; formatprn(ab);
	int lz=(int)(-log10int(ab));  // lz (leading zeros) is where the difference begins in interval (a,b).
	int nprec=(int)((double)lz/0.30103)/10;   // convert tol to binary, then 1024=2^10
	std::cout << " first nprec=" << nprec << std::endl;
 	while( it < maxit){
//		std::cout << "It=" << it << " nprec=" << nprec << std::endl;;
 		if(fa*fb > rational::ZERO){
 			std::cout << " newton error  a=" << std::setprecision(16) << (double)a << " b=" << (double)b << " fa=" << (double)fa <<  " fb=" << (double)fb << " STOP" <<  std::endl;
 			exit(3);
 		}
 		it++; totalit++;
 		if(it >= maxit){
 			std::cout << " newton MAXIT reached it=" << it << std::endl;
 			rtnval=-it; break;
 		}
		rational dd=(a+b)/rational::TWO;   // use mid-point
 		Horner3(n,p,dd,fd,fdd,fddd);
 		d = dd-fd/fdd;                     // Newton-Raphson estimates d from mid-point
		rational cab=min(d-a,b-d);         // smaller interval cab = min(d-a,b-d)
		interval d2=roundrat(d,nprec);     // round d to interval having power of 2
		rational dl=d2.lower(); rational du=d2.upper(); rational dm=(dl+du)/rational::TWO;
		rational fdl=Horner(n,p,dl); rational fdu=Horner(n,p,du);
		if(fdl*fdu<rational::ZERO){        // Rough inclusion
			a=dl; b=du; fa=fdl; fb=fdu;
			std::cout << " Rough inclusion successful with nprec=" << nprec << ", ";
			while(true){
				nprec++;
				d2=roundrat(d,nprec); // round d to interval having power of 2 in their denominators
				dl=d2.lower(); du=d2.upper();
				fdl=Horner(n,p,dl); fdu=Horner(n,p,du);
				if(fdl*fdu<rational::ZERO){
					a=dl; b=du; fa=fdl; fb=fdu;
				}else{
					for(int m=1; m<10; m++){ //   step with * 2 
						d2=roundrat2(d,nprec-1,m); // round d 
						dl=d2.lower(); du=d2.upper();
						fdl=Horner(n,p,dl); fdu=Horner(n,p,du);
						if(fdl*fdu<rational::ZERO){
							a=dl; b=du; fa=fdl; fb=fdu;
						}else{
							std::cout << " improve accuracy stop with m=" << m << std::endl;
							break;
						}
					}
					break;
				}
			}
			interval xy(a,b); int lz=(int)(-log10int(xy)); 
 			if(lz > tol){ 
//				fdl=Horner(n,p,a); fdu=Horner(n,p,b);
				std::cout << " newton Converged it=" << it << " b-a=" << std::setprecision(16) << (double)(b-a) << std::endl;
//				std::cout << " newton Converged it=" << it << " b-a=" << std::setprecision(16) << (double)(b-a) << " f(a)=" << (double)fdl << " f(b)=" << (double)fdu <<std::endl;
// 				rtnval=it; break;
 				rtnval=it; ab=xy; break;           /////////  2016nov07
 			}
		}else{      //  Fail in rough inclusion
			std::cout << " Rough inclusion UNsuccessful with nprec=" << nprec << std::endl;
			std::cout << " interval(d2)=" << std::endl; formatprn(d2);
 			rtnval=-nprec; break;           /////////  2016nov07
		}
		interval xy(a,b); int lz=(int)(-log10int(xy));
 		if(lz > tol){ 
//			fdl=Horner(n,p,a); fdu=Horner(n,p,b);
			std::cout << " Newton Converged it=" << it << " b-a=" << std::setprecision(16) << (double)(b-a) << " lz=" << lz << " tol=" << tol << std::endl;
 			c=d; rtnval=it;
//			ab=xy; break;           /////////  2016nov07
			ab=xy; exit(3);         /////////  2016nov08
 		}
	}
 	return rtnval;
 }


interval setpi(const uint32_t tol)
{                //  this routine should be used as the first function
	uint32_t i=1;  //  because this routine set and reset lgcd_p
	longint p,q,p0,q0,p1,q1,x;
	rational pp,qq,pq,pq0;
	interval pi;
	longint::lgcd_p = longint::lgcd1;

	p=longint::TEN;
	for(uint32_t j=1; j<tol; j++) p=p*longint::TEN;
	rational rtol(longint::ONE,p);

	p0=longint::FOUR; q0=longint::ONE;
	p1=longint::TEN+longint::TWO; q1=longint::FOUR;
	while(true){
		i++; x=i;
		p=(longint::TWO*x+longint::ONE)*p1+(x*x)*p0;
		q=(longint::TWO*x+longint::ONE)*q1+(x*x)*q0;
		pp=RRset(p,longint::ONE); qq=RRset(q,longint::ONE);
		pq=pp/qq;
		if(i>3){
			if((pq0-pq).abs() < rtol) break;
		}
		pq0=pq;
		p0=p1; q0=q1;
		p1=p;  q1=q;
	}
	//------------------------------------------------------
	longint::lgcd_p = longint::lgcd2;
	pq0=pq0*rational::ONE;
	pq=pq*rational::ONE;
//	std::cout << " p=" << p <<  std::endl;
//	std::cout << " q=" << q <<  std::endl;
//	std::cout << "digits of pq=" << getdgts(pq) <<  std::endl;
//	std::cout << " pq0=" << pq0 <<  std::endl;
	if(pq0 < pq){
		pi=interval(pq0,pq);
	}else{
		pi=interval(pq,pq0);
	}
	return pi;
}

rational sqrt2(longint X, uint32_t tol){   // sqrt 2, see CfracSqr2.BAS
	longint p0,p1,p,q0,q1,q;
	rational r, r0;
	p0=longint::ONE;   q0=longint::ONE;
	p1=longint::THREE; q1=longint::TWO;
	int i=1;
	while(true){
#ifdef SQRT2NAIVE
		p=longint::TWO*p1+p0;
		q=longint::TWO*q1+q0;
		int nbq=numbits(q);
		if((uint32_t)(2*(double)nbq*0.30103) > tol){
//			std::cout << " sqrt2 converge i="<< i << std::endl;
			break;
		}
		p0=p1; q0=q1; p1=p; q1=q; i++;
#else
		int nbq;       //  2016oct08  15% faster, but sqrt4g is faster
		if(i%2==1){
			p0+=longint::TWO*p1;
			q0+=longint::TWO*q1;
			nbq=numbits(q0);
		}else{
			p1+=longint::TWO*p0;
			q1+=longint::TWO*q0;
			nbq=numbits(q1);
		}
		if((uint32_t)(2*(double)nbq*0.30103) > tol){
//			std::cout << " sqrt2 converge i="<< i << std::endl;
			break;
		}
		i++;
#endif
	}
#ifdef SQRT2NAIVE
	r=RRset(p,q); r0=RRset(p1,q1);
#else
	if(i%2==1){
		r=RRset(p0,q0); r0=RRset(p1,q1);
	}else{
		r=RRset(p1,q1); r0=RRset(p0,q0);
	}
#endif
	/*****************************************
	interval a;
	if(r0<r){
		interval tmp(r0,r); a=tmp;
	}else{
		interval tmp(r,r0); a=tmp;
	}
	std::cout << " SQR2="; formatprn(a);
	*****************************************/
	return r;
}

rational sqrt4g(const longint& X, const uint32_t tol){   // called by SQR
	longint R, A, B, J;
	int j, nit;
	uint32_t i,jc;
	uint64_t jb,ja,nden=0;
	long long tstart;        // timer

#ifdef SQRCHKPRT
	std::cout << " sqrt4g enter,  tol=" << tol <<  "  X.l=" << X.l << std::endl;
#endif
	uint32_t n=(uint32_t)((double)tol/4.8164799306236991234198223155919)+1;    // divide by LOG10(65536)
	if( (n-X.l)%2 == 1) n++;                  //////////// n-X.l even
#ifdef ROUGHCHECK
	rough rcrit=rough::ONE/rough::TWENTY;
#endif
//	DEN=longint::ONE;  // denominator for the number of digits under the decimal  point
	int nxl=n-X.l;
#ifdef SQRCHKPRT
	std::cout << "  nxl=" << nxl << " n=" << n << " X.l=" << X.l << std::endl;
#endif

	//////           initialize A
	if( X.l%2 == 1){ 
			A = longint::lset(X.d[X.l]);   // A=A*4294967296+X.d[i]
		}else{
			A = longint::lset(X.d[X.l])*longint::FOURGIGA+longint::lset(X.d[X.l-1]);
		}

	int uppoint=1;  // to control before or after the point

	for(j=X.l; j>(-nxl); j-=2){      /////   compute until specified accuracy with j step -2
		if(j>0){i=j;}else{i=-j;}
#ifdef SQRCHKPRT
		std::cout << " j=" << j <<  " i=" << i << " A=" << A << std::endl;
#endif
		if(j==0){
			uppoint=0;
#ifdef SQRCHKPRT
			std::cout << " sqrt4g under the decimal point, n=" << n << std::endl;
#endif
		}
		tstart=gettime();
		rough rbj;
		rough ra=numeric_cast<rough>(A);      // A converted to rough number ra
#ifdef SQRESTIMATEROOT
		int pw2=ra.exponent(); double daa=ra.significand();
#endif
		timesqrt4g1+=gettime()-tstart;
		tstart=gettime();
		if(j==X.l && X.l%2 == 1){     /////  adjust j in case of X.l odd
			ja=0; jb=65536; nit=16;
			B<<=16;
		}else{
			ja=0; jb=4294967296; nit=32;  /////////  4G
			B<<=32;
		}
		timesqrt4g2+=gettime()-tstart;
		tstart=gettime();
		rough rp=numeric_cast<rough>(B);  // B converted to rough number rp
#ifdef SQRESTIMATEROOT
		rough rr;
		if(rp == rough::ZERO){
			if(pw2%2 == 0){
				double sqraa=sqrt(daa);
				rough rx(sqraa,pw2/2);
				rr=rx;
			}else{
				double sqra2=sqrt(daa*2);
				rough ry(sqra2,(pw2-1)/2);
				rr=ry;
			}
#ifdef SQRCHK
			std::cout << " Zero rp j=" << j << " ja=" << ja << " daa=" << daa << " pw2=" << pw2 << " rr="<< std::setprecision(15) << rr << " rp=" << rp << " ra=" << ra << std::endl;
#endif
		}else{
			rr=ra/rp;
		}
///////////////////////////////////////////////////////////////////////		
#ifdef SQRCHKPRT
		std::cout << " j=" << j << " rr="<< std::setprecision(15) << rr <<  " rp=" << rp << " ra=" << ra << " rp*rr=" << rp*rr << std::endl;
#endif
///////////////////////////////////////////////////////////////////////		
		double drr=rr.significand()*pow(2.0,rr.exponent());
		uint64_t rjj=(uint64_t)drr;
//		std::cout << " rp.exponent()=" << rp.exponent() << std::endl;
		if(rp.exponent() <= 80){
			ja=0; jb=4294967296; nit=32;  /////////  4G
//			std::cout << " rp.exponent()=" << rp.exponent() << " nit="<< nit << std::endl;
		}else if(rp.exponent() <= 160){
			ja=rjj-16; jb=rjj+16; nit=5;
//			std::cout << " rp.exponent()=" << rp.exponent() << " nit="<< nit << std::endl;
		}else{
			ja=rjj-2; jb=rjj+2; nit=2;
		}
///////////////////////////////////////////////////////////////////////		
//		std::cout << " j=" << j << " drr="<< drr <<  " ja=" << ja << " rjj=" << rjj << " jb=" << jb << std::endl;
///////////////////////////////////////////////////////////////////////		
#endif
		timesqrt4g3+=gettime()-tstart;
		tstart=gettime();
		for(int k=0; k<nit; k++){       //////  iteration count is variable
			jc=(ja+jb)/2;
#ifdef ROUGHCHECK
			rough rjc=numeric_cast<rough>(jc); // jc converted to rough number rjc
			rbj=(rp+rjc)*rjc;
			rough rval=rbj/ra;
			if(rval.abs() > rcrit){            // 2016sep29, oct21 change to relative error
				if((rp+rjc)*rjc > ra){
					jb=jc;
				}else{
					ja=jc;
				}
			}else{
#endif
				longint JC=longint::lset(jc);
				if( (B+JC)*JC > A ){
					jb=jc;
				}else{
					ja=jc;
				}
#ifdef ROUGHCHECK
				std::cout << "i=" << i << " ra=" << ra << " rp=" << rp << " jc=" << jc << " rval=" << rval << std::endl;
			}
#endif
		}
		timesqrt4g4+=gettime()-tstart;
		tstart=gettime();
		J=longint::lset(ja); // determine the digit is J
		A -= ( B + J ) * J;    // a-=(b*4G+j)*j
		B += (J+J);            // b+=(j+j), left portion
//		if(j<=0) DEN <<= 32;   // denominator, the number of digits under the point
		if(j<=0) nden++;       // denominator counter, the number of digits under the point
		timesqrt4g5+=gettime()-tstart;
#ifdef SQRCHKPRT
		std::cout << " sqrt4g J="<< J <<  std::endl;
		std::cout << " sqrt4g A="<< A <<  std::endl;
		std::cout << " sqrt4g B="<< B <<  std::endl;
#endif
		tstart=gettime();
		A <<= 64;                             // A  for next iteration
		if(j==X.l && X.l%2 == 1){
			j++; /////  adjust j in case of X.l odd
//			std::cout << " adjusted j="<< j << std::endl;
		}
		if(uppoint==1 && j > 3) A += longint::lset(X.d[j-2])*longint::FOURGIGA+ longint::lset(X.d[j-3]);
		timesqrt4g6+=gettime()-tstart;
	} // 	for(j=X.l; j>(-nxl); j=j-2){      /////  j step 2
#ifdef SQRCHKPRT
	std::cout << " sqrt4g A="<< A <<  " B="<< B <<  " R =" << R << std::endl;
#endif
////////////////////////////////////////////////////////////////
//  sqrt(X) is a rational number, R=B/2, 
//  then shift decimal point with nden digits, by dividing DEN
////////////////////////////////////////////////////////////////
	R=(B>>1);
	longint DEN=longint::ONE; DEN<<=(32*nden);
	rational tmp(R,DEN);    // divide by the  GCD
	return tmp;
}

rational SQR(const rational& a, const uint32_t tol)  //  sqrt(A)
{                                                    //  A = An / Ad
	long long tstart, sstart;
	longint d, q, r;
	rational sqran, sqrad, sqra;

	tstart=gettime();
	longint an=a.numerator();        longint ad=a.denominator();
	uint32_t antz=an.longint::ctz(); uint32_t adtz=ad.longint::ctz();

	if(numbits(an)-antz == 1 || numbits(ad)-adtz == 1){  // either An or Ad is power of 2
		sstart=gettime();
		if(numbits(ad)-adtz == 1){                   // Denominator of A is power of 2
#ifdef SQRCHK
		std::cout << " SQR Ad power two" << std::endl;
#endif
			if(adtz%2 == 1){ an<<=1; ad<<=1; adtz+=1; }
			sqran=sqrt4g(an,tol);                //  sqrt(An)
			timeSQR1+=gettime()-sstart;
#ifdef SQRCHK
			std::cout << " SQR sqrt(An) time=" << (double)(gettime()-tstart)/1000000.0 << "(sec)" << std::endl;
#endif
			sstart=gettime();
			d=(longint::ONE << adtz/2);
			sqrad=RRset(d,longint::ONE);         //  sqrt(Ad)

		}else if(numbits(an)-antz == 1){             // Numerator of A is power of 2
#ifdef SQRCHK
		std::cout << " SQR An power two" << std::endl;
#endif
			if(antz%2 == 1){ an<<=1; ad<<=1; antz+=1; }
			sqrad=sqrt4g(ad,tol);                //  sqrt(Ad)
			timeSQR1+=gettime()-sstart;
#ifdef SQRCHK
			std::cout << " SQR sqrt(Ad) time=" << (double)(gettime()-tstart)/1000000.0 << "(sec)" << std::endl;
#endif
			sstart=gettime();
			d=(longint::ONE << antz/2);
			sqran=RRset(d,longint::ONE);         //  sqrt(An)
		}
		sqra=sqran / sqrad;
		timeSQR2+=gettime()-sstart;
#ifdef SQRCHKPRT
		std::cout << " sqran=" << sqran << std::endl;
		std::cout << " sqrad=" << sqrad << std::endl;
#endif

	}else{          // both Numerator of A and Denominator of A are not power of 2
#ifdef SQRCHK
		std::cout << " SQR use fraction" << std::endl;
#endif
		sstart=gettime();
		int32_t m=numbits(an)-numbits(ad); // convert rational number (an/ad) to radix=2^{32} fractional number 
		uint32_t n=(uint32_t)((double)(tol-m)/0.3010299956639812)/32+1;  // divide by LOG10(2) / 32
		if(n%2==1) n+=1;                   // decide number of digits of q
		longint temp=(an<<(32*n));
		q=longint::ldivide(temp,ad,&r);    // quatient is the number to be find square root
		if(r >= longint::TWOGIGA) q+=longint::ONE;  // rounding up, if residue > 2G
		timeSQR1+=gettime()-sstart;

		sstart=gettime();
		rational sq=sqrt4g(q,tol);         // sqrt(Q)
		d=(sq.denominator()<<(16*n));
		sqra=RRset(sq.numerator(),d);      // sqrt(A)
		timeSQR2+=gettime()-sstart;
	}
#ifdef SQRCHK
	std::cout << " SQR sqrt(A) time=" << (double)(gettime()-tstart)/1000000.0 << "(sec)" << std::endl;
#endif
#ifdef SQRCHKPRT
	std::cout << " sqra=" << sqra << " (double)sqra=" << (double)sqra << std::endl;
#endif
#ifdef SQRCHK
	std::cout << " SQR An/Ad time=" << (double)(gettime()-tstart)/1000000.0 << "(sec)" << std::endl;
	tstart=gettime();
	rational ss=sqra*sqra;
//  ******* 2017feb06 *******************
//	longint ssd = ss.denominator();
// 	longint ssn = ss.numerator();
//	std::cout << " NumDgts N/D=" << numdgts(ssn) << " / " << numdgts(ssd) << std::endl;
//  *************************************
	if(a<ss){
		interval ass(a,ss);
		std::cout << " SQR (a,s*s)="; formatprn(ass);
	}else if(a>ss){
		interval ass(ss,a);
		std::cout << " SQR (s*s,a)="; formatprn(ass);
	}else{
		interval ass(ss,a);
		std::cout << " SQR (s*s=a)="; formatprn(ass);
	}
	std::cout << " SQR make interval time=" << (double)(gettime()-tstart)/1000000.0 << "(sec)" << std::endl;
#endif
	return sqra;
}

interval SQRint(const rational& a, const uint32_t tol) // (sqrt(A)_lower, sqrt(A)_upper)
{                                                      //  A = An / Ad
	long long tstart, sstart;
	longint d, q, r, sn, sd;
	rational sqran, sqrad, sqra, sqra1;

	tstart=gettime();
	longint an=a.numerator();        longint ad=a.denominator();
	uint32_t antz=an.longint::ctz(); uint32_t adtz=ad.longint::ctz();
	if(numbits(an)-antz == 1 || numbits(ad)-adtz == 1){  // either An or Ad is power of 2
		sstart=gettime();
		if(numbits(ad)-adtz == 1){  // Denominator of A is power of 2
#ifdef SQRCHK
		std::cout << " SQRint Ad power of two" << std::endl;
#endif
			if(adtz%2 == 1){ an<<=1; ad<<=1; adtz+=1; }
			sqran=sqrt4g(an,tol);           // sqrt(An)
			sn=sqran.numerator();
			rational sqran1(sn+longint::ONE,sqran.denominator());  // sqrt(An) + 1/Den
			timeSQR1+=gettime()-sstart;
#ifdef SQRCHK
			std::cout << " SQRint sqrt{an} time=" << (double)(gettime()-tstart)/1000000.0 << "(sec)" << std::endl;
#endif
			sstart=gettime();
			d=(longint::ONE << adtz/2);
			sqrad=RRset(d,longint::ONE);     // sqrt(Ad)
			sqra=sqran / sqrad;              // sqrt(A)_lower
			sqra1=sqran1 / sqrad;            // sqrt(A)_upper

		}else if(numbits(an)-antz == 1){  // Numerator of A is power of 2
#ifdef SQRCHK
		std::cout << " SQRint An power two" << std::endl;
#endif
			if(antz%2 == 1){ an<<=1; ad<<=1; antz+=1; }
			sqrad=sqrt4g(ad,tol);           // sqrt(Ad)
			sn=sqrad.numerator(); 
			rational sqrad1(sn+longint::ONE,sqrad.denominator());  // sqrt(Ad) + 1/Den
			timeSQR1+=gettime()-sstart;
#ifdef SQRCHK
			std::cout << " SQRint sqrt(Ad) time=" << (double)(gettime()-tstart)/1000000.0 << "(sec)" << std::endl;
#endif
			sstart=gettime();
			d=(longint::ONE << antz/2);
			sqran=RRset(d,longint::ONE);    // sqrt(An)
			sqra=sqran / sqrad1;            // sqrt(A)_lower
			sqra1=sqran / sqrad;            // sqrt(A)_upper
		}
		timeSQR2+=gettime()-sstart;
#ifdef SQRCHKPRT
		std::cout << " sqran=" << sqran << std::endl;
		std::cout << " sqrad=" << sqrad << std::endl;
#endif

	}else{          // both Numerator of A and Denominator of A are not power of 2
#ifdef SQRCHK
		std::cout << " SQRint make fractional expression" << std::endl;
#endif
		sstart=gettime();
		int32_t m=numbits(an)-numbits(ad); // convert rational number (an/ad) to radix=2^{32} number 
		uint32_t n=(uint32_t)((double)(tol-m)/0.3010299956639812)/32+1;  // divide by LOG10(2) / 32
		if(n%2==1) n+=1;                   // decide number of digits of q
		longint temp=(an<<(32*n));
		q=longint::ldivide(temp,ad,&r);    // quatient is the number
//		if(r >= longint::TWOGIGA) q+=longint::ONE;  // rounding up, if residue > 2G
		timeSQR1+=gettime()-sstart;

		sstart=gettime();
		rational sq=sqrt4g(q,tol);         // sqrt{q} smaller one
		sn=sq.numerator();
		d=(sq.denominator()<<(16*n));
		sqra=RRset(sq.numerator(),d);      // sqrt(A)_lower,  since q is rounded smaller
		sqra1=RRset(sq.numerator()+longint::ONE,d);    // sqrt(A)_upper
		timeSQR2+=gettime()-sstart;
	}
#ifdef SQRCHK
	std::cout << " SQRint sqrt{ad} time=" << (double)(gettime()-tstart)/1000000.0 << "(sec)" << std::endl;
#endif
#ifdef SQRCHKPRT
	std::cout << " sqra=" << sqra << " (double)sqra=" << (double)sqra << std::endl;
#endif
#ifdef SQRCHK
	std::cout << " SQRint an/ad time=" << (double)(gettime()-tstart)/1000000.0 << "(sec)" << std::endl;
	tstart=gettime();
	rational ss=sqra*sqra;
	if(a<ss){
		interval ass(a,ss);
		std::cout << " SQRint (a,s*s)="; formatprn(ass);
	}else if(a>ss){
		interval ass(ss,a);
		std::cout << " SQRint (s*s,a)="; formatprn(ass);
	}else{
		interval ass(ss,a);
		std::cout << " SQRint (s*s=a)="; formatprn(ass);
	}
	ss=sqra1*sqra1;
	if(a<ss){
		interval ass(a,ss);
		std::cout << " SQRint (a,s1*s1)="; formatprn(ass);
	}else if(a>ss){
		interval ass(ss,a);
		std::cout << " SQRint (s1*s1,a)="; formatprn(ass);
	}else{
		interval ass(ss,a);
		std::cout << " SQRint (s1*s1=a)="; formatprn(ass);
	}
	std::cout << " SQRint make interval time=" << (double)(gettime()-tstart)/1000000.0 << "(sec)" << std::endl;
#endif
	interval x(sqra,sqra1);
	return x;
}

////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////
 void cnvmat(const rat::matrix<double>& a, rat::matrix<rational>& ar, const int m, const int n)
 {
 	for(int j=0; j < n; j++){
 		for(int i=0; i < m; i++){
 //			ar[i][j] = a[i][j];
 			double t=a[i][j];
// 			ar[i][j] = Rdset(&a[i][j]);
 			ar[i][j] = Rdset(&t);
 		}
 	}
 }

void copymat(const rat::matrix<rational>& a, const int m, const int n, rat::matrix<rational>& c){
	for (int j=0; j < n; ++j){  // column j
		for (int i=0; i < m; ++i)  c[i][j]=a[i][j];
	}
} 

 rational rat2int(const rat::matrix<rational>& a, const int n, rat::matrix<rational>& b)
 {
 	longint gcdd, sd, lcm;
 	gcdd = a[0][0].denominator();
 	lcm = longint::ONE;
 	for (int i=0; i<n; i++){
 		for (int j=0; j<n; j++){
 			if(a[i][j] == rational::ZERO) continue;
 			sd = a[i][j].denominator();
 			if(gcdd != longint::ZERO && lcm != longint::ZERO) gcdd=(*longint::lgcd_p)(sd,lcm); 
 			lcm=lcm*sd;
 			lcm=lcm/gcdd;
 		}
 	}
 	rational Cof = RRset(lcm,longint::ONE);
 	for (int i=0; i<n; i++){
 		for (int j=0; j<n; j++){
 			b[i][j] = a[i][j]*Cof;
 		}
 	}
 	return  Cof;
 }
 
 longint matngcd(const rat::matrix<rational>& a, const int n)
 {   // gcd of numerator of matrix A
 	longint mgcd, k, m;
 	mgcd =  a[0][0].numerator();
 	for (int i=0; i<n; i++){
 		for (int j=0; j<n; j++){
 			if(a[i][j] == rational::ZERO) continue;
 			k = a[i][j].numerator();
 			m=(*longint::lgcd_p)(mgcd,k); 
 			mgcd=m;
 		}
 	}
 	return mgcd;
 }
 
 void matprn(const rat::matrix<double>& a, const int m, const int n)
 {
 	for(int i=0; i < m; i++){
 		for(int j=0; j < n; j++){
 			std::cout << a[i][j] << " ";
 		}
 		std::cout << std::endl;
 	}
 }
 
 void matprn(const rat::matrix<rational>& a, const int m, const int n)
 {
 	for(int i=0; i < m; i++){
 		for(int j=0; j < n; j++){
 			std::cout << a[i][j] << " ";
 		}
 		std::cout << std::endl;
 	}
 }
 
 void matprt(const rat::matrix<rational>& a, const int m, const int n)
 {
 	for(int i=0; i < m; i++){
 		for(int j=0; j < n; j++){
 			std::cout << (double)a[i][j] << " ";
 		}
 		std::cout << std::endl;
 	}
 }
 
 void elmhes(rat::matrix<rational>& a, const int n) {
 	rational x, y;
 	int i;
 //
 	std::cout << "elmhes  start n=" << n  << std::endl;
 //
 	for (int m=2; m <= n-1; ++m) {
 
 		x = rational::ZERO;
 		i = m;
 		for(int j=m; j<=n; ++j) {
 			if(fabs(a[j-1][m-2]) > fabs(x)){
 				x = a[j-1][m-2];
 				i = j;
 			}
 		}
 		longint xd = x.denominator();
 		longint xn = x.numerator();
 		std::cout << "m=" << m << " i=" << i << " x=" << x.format(30,10)  <<  " NumDgts N/D=" << numdgts(xn) << " / " << numdgts(xd) << std::endl;
 		if (i != m) {
 			for(int j=m-1; j<=n; ++j) {
// 				y = a[i-1][j-1];
// 				a[i-1][j-1] = a[m-1][j-1];
// 				a[m-1][j-1] = y;
				rational::swap(a[i-1][j-1],a[m-1][j-1]);
 			}
 			for(int j=1; j<=n; ++j) {
// 				y = a[j-1][i-1];
// 				a[j-1][i-1] = a[j-1][m-1];
// 				a[j-1][m-1] = y;
				rational::swap(a[j-1][i-1],a[j-1][m-1]);
 			}
 		}
 
 		if (x != rational::ZERO) {
 			for(int i=m+1; i<=n; ++i) {
 				y = a[i-1][m-2]; 
 				if (y != rational::ZERO) {
 					y = y / x; 
 					a[i-1][m-2] = y; 
// 					for(int j=m; j<=n; ++j) a[i-1][j-1] = a[i-1][j-1] - y * a[m-1][j-1];
					rat::lmatrix_row<rational> arow2(a,i-1,m-1,n-1,1);
#ifdef RBLAS
					rat::raxpy(-y,a.row(m-1,m-1,n-1,1),arow2);
#else
					rat::praxpy(-y,a.row(m-1,m-1,n-1,1),arow2);
#endif
// 					for(int j=1; j<=n; ++j)	a[j-1][m-1] += y * a[j-1][i-1];
					rat::lmatrix_column<rational> acol2(a,m-1,0,n-1,1); 
#ifdef RBLAS
					rat::raxpy(y,a.column(i-1,0,n-1,1),acol2);
#else
					rat::praxpy(y,a.column(i-1,0,n-1,1),acol2);
#endif
 				}
 				a[i-1][m-2] = rational::ZERO;
 			}
 		}
#ifdef SEEMATNUMDGTS
		MatDgtCountPrt(a,n,n);
#endif
 	}
 }
 
 void hesfrb(rat::matrix<rational>& a, const int n, rat::vector<rational>& p)
 {
 	std::cout << "hesfrb  start n=" << n  << std::endl;
	long long tstart = gettime();
 	rational t;
	rat::vector<rational> sd(n+1);   // subdiagonal terms
	rat::vector<rational> tt(n+1);
 	int i, j, k;
/********************************************************************** 
	for (k=1; k <= n-1; ++k) {
		for (i=1; i <= k; ++i) {
			p[i-1] = a[i-1][k-1] / a[k][k-1];
			a[i-1][k-1] = rational::ZERO;
		}
		for (j=k+1; j <= n; ++j) {
			for (i=1; i <= k; ++i) a[i-1][j-1] = a[i-1][j-1] - p[i-1] * a[k][j-1]; //raxpy
		}
		for (i=2; i <= k+1; ++i) a[i-1][k] += p[i-2] * a[i-1][i-2];                    //raxpy
	}

	t = rational::ONE;
	for (i=n; i > 1; --i) {
		p[n-i+1] = a[i-1][n-1] * t;                  // tt[*] is used, rvma
		t = t * a[i-1][i-2];                         //  DEPENDENCY
	}
	p[n] = t * a[0][n-1];
	p[0] = -rational::ONE;
	if(n%2 ==0){
		for (i=0; i <= n; ++i) p[i] = -p[i];
	}
**********************************************************************/
 	for (k=1; k < n; ++k) sd[k]=a[k][k-1];
	sd[0]=rational::ONE; sd[n]=rational::ONE;

 	for (k=1; k <= n-1; ++k) {
// 		for (i=1; i <= k; ++i) {
// 			p[i-1] = a[i-1][k-1] / a[k][k-1];
// 			a[i-1][k-1] = rational::ZERO;
// 		}
		for (i=1; i <= k; ++i) p[i-1]=rational::ZERO;
//		rational akkm1=a[k][k-1].inv();
		rational akkm1=rational::ONE/a[k][k-1];
//		t=a[k][k-1];
//		rational akkm1=t.inv();
		rat::lvector_section<rational> ps0(p,0,k-1,1);
#ifdef RBLAS
		rat::raxpy(akkm1,a.column(k-1,0,k-1,1),ps0);
#else
		rat::praxpy(akkm1,a.column(k-1,0,k-1,1),ps0);
#endif
 		for (i=1; i <= k; ++i) a[i-1][k-1]=rational::ZERO;
 		for (j=k+1; j <= n; ++j) {
// 			for (i=1; i <= k; ++i) a[i-1][j-1] = a[i-1][j-1] - p[i-1] * a[k][j-1];
			rat::lmatrix_column<rational> acol0(a,j-1,0,k-1,1);
#ifdef RBLAS
			rat::raxpy(-a[k][j-1],p.section(0,k-1,1),acol0);
#else
			rat::praxpy(-a[k][j-1],p.section(0,k-1,1),acol0);
#endif
 		}
// 		for (i=2; i <= k+1; ++i) {
// 			a[i-1][k] += p[i-2] * a[i-1][i-2];
// 			a[i-1][k] += p[i-2] * sd[i-1];
// 		}
		rat::lmatrix_column<rational> acol1(a,k,1,k,1); 
#ifdef RBLAS
		rat::rvma(p.section(0,k-1,1),sd.section(1,k,1),acol1);
//		rat::rvma(p.section(0,k-1,1),sd.section(k,1,-1),acol1);
#else
		rat::prvma(p.section(0,k-1,1),sd.section(1,k,1),acol1);
//		rat::prvma(p.section(0,k-1,1),sd.section(k,1,-1),acol1);
#endif
 		longint xd = a[k][k-1].denominator(); longint xn = a[k][k-1].numerator();
// 		std::cout << "k_{" << k+1 << "}=" << a[k][k-1].format(30,10) <<  " NumDgts N/D=" << numdgts(xn) << " / " << numdgts(xd) << " " << xn << " " << xd << std::endl;
 		std::cout << "k_{" << k+1 << "}=" << a[k][k-1].format(30,10) <<  " NumDgts N/D=" << numdgts(xn) << " / " << numdgts(xd) << std::endl;
// 		std::cout << "system'factor " << xn << "';" <<  std::endl;
// 		std::cout << "system'factor " << xd << "';" <<  std::endl;
 	}
	std::cout << " hesfrb transform to  X time=" << (double)(gettime()-tstart)/1000000.0 << "(sec)" << std::endl;
#ifdef SEEMATNUMDGTS
	MatDgtCountPrt(a,n,n);
 	std::cout << "X" << std::endl;
 	for (i=0; i < n; ++i) {
 		longint xd = a[i][n-1].denominator();
 		longint xn = a[i][n-1].numerator();
 		std::cout << "x[" << i << "]=" << a[i][n-1].format(50,10)  << " NumDgts N/D=" << numdgts(xn) << " / " << numdgts(xd) <<  std::endl;
	}
#endif

#ifdef HESFRBRSCAL
 	for (i=1; i <= n; ++i) p[n-i+1]=a[i-1][n-1];   // set in reversal order
 	std::cout << "p initial set" << std::endl;
 	for (i=1; i <= n; ++i) std::cout << "p[" << i << "]=p_{" << n-i << "}=" << p[i].format(50,10) << std::endl;
	for (i=n-1; i >= 1; --i) {
		if(i==1){
		 	std::cout << "Call RedVecDgt" << std::endl;
		 	RedVecDgt(sd,n-1,longint::ONE);

		}
		rat::lvector_section<rational> ps3(p,i+1,n,1);
#ifdef RBLAS
		rat::rscal(sd[n-i],ps3);
#else
		rat::prscal(sd[n-i],ps3);
#endif
#ifdef SEEMATNUMDGTS
 		std::cout << "i=" << i << " reduction" << std::endl;
 		for (j=i+1; j <= n; ++j) {
 			longint xd = p[j].denominator(); longint xn = p[j].numerator();
 			std::cout << "p[" << j << "]=p_{" << n-j << "}=" << p[j].format(50,10)  << " Numdgts N/D=" << numdgts(xn) << " / " << numdgts(xd) << std::endl;
 		}
#endif
	}
#else // no HESFRBRSCAL
// 	std::cout << "prod_{j=0}^{n-2-i} k_{n-j}" << std::endl;
 	t = rational::ONE;
 	for (i=n; i > 1; --i) {
 		tt[i] = t;
 		t = t * sd[i-1];  //  t = t * a[i-1][i-2];
 	}
 	tt[1] = t;
	std::cout << " hesfrb tt time=" << (double)(gettime()-tstart)/1000000.0 << "(sec)" << std::endl;

 	for (i=1; i < n; ++i) 	p[i] = rational::ZERO;

	rat::lvector_section<rational> ps1(p,n-1,1,-1);
#ifdef RBLAS
	rat::rvma(a.column(n-1,1,n-1,1),tt.section(2,n,1),ps1);
#else
	rat::prvma(a.column(n-1,1,n-1,1),tt.section(2,n,1),ps1);
#endif
 	p[n] = tt[1] * a[0][n-1];
#endif // HESFRBRSCAL
// 	std::cout << "characteristic polynomial" << std::endl;
// 	for (i=n; i > 1; --i) {
// 		longint xd = p[n-i+1].denominator(); longint xn = p[n-i+1].numerator();
// 		std::cout << "p[" << n-i+1 << "]=" << p[n-i+1].format(50,10)  << " NumDgts N/D=" << numdgts(xn) << " / " << numdgts(xd) << std::endl;
// 	}
// 	longint xd = p[n].denominator(); longint xn = p[n].numerator();
// 	std::cout << "p[" << n << "]=" << p[n].format(50,10)  << " NumDgts N/D=" << numdgts(xn) << " / " << numdgts(xd) << std::endl;
 	p[0] = -rational::ONE;
 	if(n%2 ==0){
 		for (i=0; i <= n; ++i) p[i] = -p[i];
 	}
	std::cout << " hesfrb total time=" << (double)(gettime()-tstart)/1000000.0 << "(sec)" << std::endl;
 }

 void LUdecomp(rat::matrix<rational>& a, const int n, rat::vector<int>& ipvt, rat::vector<int>& jpvt, int& krank){
 	int k, ip, jp, ix, jx;
 	krank=n;
 	for (k=1; k <= n-1; ++k) {
 		std::cout << " LUdecomp k=" << k << " a[k][k]=" << (double)a[k-1][k-1] << std::endl;
 		ip=0; jp=0;
 		if(a[k-1][k-1] == rational::ZERO){  // find non-zero element from right-lower submatrix
 			if(k <= n-1){
 				for (jx=0; jx <= n-k; ++jx){
 					for (ix=0; ix <= n-k; ++ix){
 						if(a[k+ix-1][k+jx-1] != rational::ZERO){
 							ip=ix; jp=jx;
 							goto FOUND;
 						}
 					}
 				}
 FOUND:				std::cout << "nz found val=" << a[k+ip-1][k+jp-1] << " ip=" << ip << " jp=" << jp << std::endl;
 				if(ip != 0){
// 					std::cout << "row interchange k=" << k << " k+ip=" << k+ip << std::endl;
// 					rat::rswap(a.lrow(k-1),a.lrow(k-1+ip));
 					rat::lmatrix_row<rational> row1(a,k-1); rat::lmatrix_row<rational> row2(a,k-1+ip);
#ifdef RBLAS
 					rat::rswap(row1,row2);  // 2016jan25
#else
// 					rat::prswap(row1,row2);  // 2016jan26
 					rat::rswap(row1,row2);  // 2016jan26
#endif
 				}
 				if(jp != 0){
// 					std::cout << "col interchange k=" << k << " k+jp=" << k+jp << std::endl;
// 					rat::rswap(a.lcolumn(k-1),a.lcolumn(k-1+jp));
 					rat::lmatrix_column<rational> col1(a,k-1); rat::lmatrix_column<rational> col2(a,k-1+jp);
#ifdef RBLAS
 					rat::rswap(col1,col2);  // 2016jan26
#else
// 					rat::prswap(col1,col2);  // 2016jan26
 					rat::rswap(col1,col2);  // 2016jan26
#endif
 				}
 			}
 			if(ip == 0 && jp == 0){
 				std::cout << "LUdecomp matrix singular k=" << k << std::endl;
 				krank=k-1;
				goto TING;  // SING 
 			}
 		}
 		ipvt[k-1]=ip+k-1; jpvt[k-1]=jp+k-1;
 		std::cout << "pivot k=" << k << " ipvt[k-1]=" << ipvt[k-1] << " jpvt[k-1]=" << jpvt[k-1] << std::endl;
 		rat::lmatrix_column<rational> col1(a,k-1,k,n-1,1);
 		rat::lmatrix_section<rational> submat(a,k,n-1,1,k,n-1,1);
#ifdef RBLAS
// 		rat::rscal(rational::ONE/a[k-1][k-1],a.lcolumn(k-1,k,n-1,1));
// 		rat::rger(-rational::ONE, a.column(k-1,k,n-1,1), a.row(k-1,k,n-1,1), a.lsection(k,n-1,1,k,n-1,1));
 		rat::rscal(rational::ONE/a[k-1][k-1],col1);
 		rat::rger(-rational::ONE, a.column(k-1,k,n-1,1), a.row(k-1,k,n-1,1), submat);
#else
//		rat::prscal(rational::ONE/a[k-1][k-1],a.lcolumn(k-1,k,n-1,1));
// 		rat::prger(-rational::ONE, a.column(k-1,k,n-1,1), a.row(k-1,k,n-1,1), a.lsection(k,n-1,1,k,n-1,1));
 		rat::prscal(rational::ONE/a[k-1][k-1],col1);
 		rat::prger(-rational::ONE, a.column(k-1,k,n-1,1), a.row(k-1,k,n-1,1), submat); 
#endif
 	}
 	if(a[n-1][n-1] == rational::ZERO){  // find non-zero element from right-lower submatrix
 		std::cout << "LUdecomp matrix singular k=" << n << std::endl;
 		krank=n-1;
 	}
TING:	std::cout << "LUdecomp finish Rank=" << krank << std::endl;
}
 
 void LUsubst(const rat::matrix<rational>& a, const int n, rat::vector<rational>& x, const rat::vector<int>& ipvt, const rat::vector<int>& jpvt) {
 	int i,j;
 	std::cout  << std::endl << "LUsubst: n=" << n << " ipvt=" << ipvt <<  " jpvt=" << jpvt << std::endl;
 	for (j=0; j < n-1; ++j) {
 		if(ipvt[j] != j){
 			rational::swap(x[j],x[ipvt[j]]);
 		}
 	}
 	for (j=0; j < n-1; ++j) {
//		for (i=j+1; i < n; ++i) x[i]=x[i]-a[i][j]*x[j];
		rat::lvector_section<rational> xs1(x,j+1,n-1,1);  // 2016jan24
#ifdef RBLAS
// 		rat::raxpy(-x[j], a.column(j,j+1,n-1,1),x.lsection(j+1,n-1,1));
		rat::raxpy(-x[j],a.column(j,j+1,n-1,1),xs1);      // 2016jan24
#else
// 		rat::praxpy(-x[j], a.column(j,j+1,n-1,1),x.lsection(j+1,n-1,1));
 		rat::praxpy(-x[j], a.column(j,j+1,n-1,1),xs1);
#endif
//		std::cout << "FWD x[" << j << "]=" << x[j] << std::endl;
 	}
 	for (i=n-1; i >= 0; --i) { 
 		x[i] = x[i]/a[i][i];
//		std::cout << "BWD x[" << i << "]=" << x[i] << std::endl;
//		for (k=0; k <= i-1; ++k) x[k]=x[k]-x[i]*a[k][i];
		rat::lvector_section<rational> xs2(x,0,i-1,1);  // 2016jan26
#ifdef RBLAS
// 		rat::raxpy(-x[i],a.column(i,0,i-1,1),x.lsection(0,i-1,1));
 		rat::raxpy(-x[i],a.column(i,0,i-1,1),xs2);      // 2016jan26
#else
// 		rat::praxpy(-x[i],a.column(i,0,i-1,1),x.lsection(0,i-1,1));
 		rat::praxpy(-x[i],a.column(i,0,i-1,1),xs2);     // 2016jan26
#endif
 	}
 	for (i=n-2; i >= 0; --i) {
 		if(jpvt[i] != i){
 			rational::swap(x[i],x[jpvt[i]]);
 		}
 	}
 }
 

void solhmg(rat::matrix<rational>& a, const int n, int& rank, rat::matrix<rational>& x){
	rat::matrix<rational> c(n,n);
	rat::vector<rational> y(n), z(n);
	rat::vector<int> ipvt(n), jpvt(n), kpvt(n), kk(n);

	copymat(a,n,n,c);
	LUdecomp(a,n,ipvt,jpvt,rank);
	std::cout << " solhmg LUdecomp finish rank=" << rank << std::endl;
//	std::cout << " solhmg LUdecomp finish rank=" << rank << " L and U=" << std::endl;
//	matprn(a,n,n);
//	matprt(a,n,n);
	std::cout << "  ipvt=" << ipvt << std::endl;
	std::cout << "  jpvt=" << jpvt << std::endl;
	///////////////////////////////////
//	rat::matrix<rational> aa(rank,rank);
//	copymat(a,rank,rank,aa);
	///////////////////////////////////

	if(rank==n){
		std::cout << " solhmg message rank full" << std::endl;
		for (int i=0; i < n; ++i) y[i]=i+1;   // set righthand-side vector
#ifdef RBLAS
		rat::rgemv(rational::ONE,c,y,rational::ZERO,z);
#else
		rat::prgemv(rational::ONE,c,y,rational::ZERO,z);
#endif
		LUsubst(a,n,z,ipvt,jpvt);
		std::cout << " solution vector" << std::endl;
		std::cout << "z=" << z << std::endl;
	} else {
		std::cout << " solhmg message matrix singular" << std::endl;
		for (int i=0; i < n; ++i) kk[i]=i;   // set for pseudo permutation 
		for (int i=rank-1; i >= 0; --i){
			if(jpvt[i] != i) std::swap(kk[i],kk[jpvt[i]]);
		}
//		for (int i=0; i < n; ++i) std::cout << kk[i] << std::endl;
		for (int k=rank-1; k <= n-2; ++k){
			int kkk=k+1;
			for (int i=0; i <= rank-1; ++i){   // search column indext for jpvt(rank)
				if(kk[i] == k+1) kkk=i;
			}
			std::cout << "solve homogeneous equation for column " << k+1 << " jpvt(kkk)=k+1 of kkk=" << kkk << std::endl;
			for (int i=0; i < n; ++i) y[i]=-c[i][kkk];     // set righthand-side vector
//			std::cout << " RHS before permutation" << std::endl;
//			for (int i=0; i < n; ++i){
//				std::cout << " y[" << i << "]=" << (double)y[i];
//			}
//			std::cout << std::endl;
			for (int i=0; i <= rank-2; ++i){
				kpvt[i]=i;
				if(ipvt[i] != i) rational::swap(y[i],y[ipvt[i]]);
			}
			kpvt[rank-1]=rank-1;
//			std::cout << " RHS after permutation" << std::endl;
//			std::cout << "y=" << y << std::endl;
			for (int i=rank; i <= n-1; ++i) y[i]=0;   // clear values in permutation position
			y[k+1]=1;                                 // set x_2=1
//			std::cout << " RHS again" << std::endl;
//			std::cout << "y=" << y << std::endl;
			LUsubst(a,rank,y,kpvt,kpvt);            // substitution without pivoting
//			std::cout << " solution vector before permutation" << std::endl;
//			std::cout << "y=" << y << std::endl;
			for (int i=rank-1; i >= 0; --i){
				if(jpvt[i] != i) rational::swap(y[i],y[jpvt[i]]);
			}
//			std::cout << " solution vector after permutation" << std::endl;
//			for (int i=0; i < n; ++i){
//				std::cout << " y[" << i << "]=" << (double)y[i];
//			}
//			std::cout << std::endl;
#ifdef RBLAS
			rat::rgemv(rational::ONE,c,y,rational::ZERO,z);
#else
			rat::prgemv(rational::ONE,c,y,rational::ZERO,z);
#endif
//			std::cout << "check zero correct" << std::endl;
//			std::cout << "z=" << z << std::endl;
			std::cout << "col num=" << k-rank+1  << std::endl;
			for (int i=0; i < n; ++i) x[i][k-rank+1]=y[i];
			for (int i=0; i < n; ++i){
				std::cout << " x[" << i << "][" << k-rank+1 << "]=" << (double)x[i][k-rank+1];
			}
			std::cout << std::endl;
		}
	}
	
}

void LDL(rat::matrix<rational>& a, const int n){
    rational s,t;
/*********************************
    int i,j,k;
    for (j=1; j < n; ++j) {
        for (i=1; i < j; ++i) {
            s=0;
            for (k=0; k < i; ++k)  s = s +  a[k][i] * a[k][j];
            a[i][j] = a[i][j] - s;
        }
        s=0;
        for (k=0; k <= j-1; ++k) {
            t = a[k][j]/a[k][k];
            s = s + t * a[k][j];
            a[k][j] = t;
        }
        a[j][j] = a[j][j] - s;
    }
*********************************/
	int ij,i,j;
	long long tstart = gettime();

	for (ij=1; ij < n; ++ij) {
//		std::cout << " LDL ij=" << ij << std::endl;
//		matprt(a,n,n);      /////////////////////////////////////
//		matprn(a,n,n);      /////////////////////////////////////
		rat::vector<rational> w(n);  // added for parallelization
		j = ij;
//		s=0;
//		for (k=0; k <= j-1; ++k) {
//			t = a[k][j]/a[k][k];
//			w[k] = a[k][j]/a[k][k];
//			s = s + t * a[k][j];
//			a[k][j] = t;
//		}
//		rat::rvdivs(a.diagonal(),a.column(j,0,j-1,1),w.lsection(0,j-1,1));
		rat::lvector_section<rational> ws1(w,0,j-1,1);  // 2016jan26
#ifdef RBLAS
//		rat::rvdivs(a.diagonal(),a.column(j,0,j-1,1),w.lsection(0,j-1,1));
		rat::rvdivs(a.diagonal(),a.column(j,0,j-1,1),ws1);
#else
//		rat::prvdivs(a.diagonal(),a.column(j,0,j-1,1),w.lsection(0,j-1,1));
		rat::prvdivs(a.diagonal(),a.column(j,0,j-1,1),ws1);
#endif

//		for (k=0; k <= j-1; ++k) {
//			s = s + w[k] * a[k][j];
//		}
//		a[j][j] = a[j][j] - s;
#ifdef RBLAS
		a[j][j] = a[j][j] - rat::rdot(w.section(0,j-1,1),a.column(j,0,j-1,1));
#else
		a[j][j] = a[j][j] - rat::prdot(w.section(0,j-1,1),a.column(j,0,j-1,1));
#endif
 		rat::lmatrix_column<rational> acol1(a,j,0,j-1,1);  //  2016jan26
#ifdef RBLAS
//		rat::rcopy(w.section(0,j-1,1),a.lcolumn(j,0,j-1,1));
		rat::rcopy(w.section(0,j-1,1),acol1);
#else
//		rat::prcopy(w.section(0,j-1,1),a.lcolumn(j,0,j-1,1));
		rat::prcopy(w.section(0,j-1,1),acol1);
#endif
		if(j%10 == 0){
			longint ajjd = a[j][j].denominator();
			longint ajjn = a[j][j].numerator();
			std::cout << "J=" << j << " Num of Dgts (Ajj)=" << numdgts(ajjd)+numdgts(ajjn) <<  std::endl;
		}
	///////////////////////////
		i = ij;
//		for (j=i+1; j < n; ++j) {
//			for (k=0; k < i; ++k) {
//				a[i][j] = a[i][j] - a[k][i] * a[k][j];
//			}
//		}
//		std::cout << " LDL n=" << n << " i=" << i << std::endl;
 		rat::lmatrix_row<rational> arow1(a,i,i+1,n-1,1);  //  2016jan26
#ifdef RBLAS
//		rat::rgemtv(-rational::ONE,a.section(0,i-1,1,i+1,n-1,1),a.column(i,0,i-1,1),rational::ONE,a.lrow(i,i+1,n-1,1));
		rat::rgemtv(-rational::ONE,a.section(0,i-1,1,i+1,n-1,1),a.column(i,0,i-1,1),rational::ONE,arow1);
#else
//		rat::prgemtv(-rational::ONE,a.section(0,i-1,1,i+1,n-1,1),a.column(i,0,i-1,1),rational::ONE,a.lrow(i,i+1,n-1,1));
		rat::prgemtv(-rational::ONE,a.section(0,i-1,1,i+1,n-1,1),a.column(i,0,i-1,1),rational::ONE,arow1);
#endif
	///////////////////////////
	}
	/********************************************************************
	for (i=0; i < n; ++i) {
		for (j=i; j < n; ++j) {
			longint aijd = a[i][j].denominator();
			longint aijn = a[i][j].numerator();
			std::cout << numdgts(aijd)+numdgts(aijn) << " " ;
		}
		std::cout <<  std::endl;
	}
	********************************************************************/
	std::cout << " LDL time=" << (double)(gettime()-tstart)/1000000.0 << "(sec)" << std::endl;
}

void LDLsubst(const rat::matrix<rational>& a, const int n, rat::vector<rational>& x)
{
	int i,j;

	for (j=0; j < n-1; ++j) {
//		for (int i=j+1; i < n; ++i) x[i] = x[i] - a[j][i]*x[j];
		rat::lvector_section<rational> xs0(x,j+1,n-1,1);  // 2016jan26
#ifdef RBLAS
//		rat::raxpy(-x[j],a.row(j,j+1,n-1,1),x.lsection(j+1,n-1,1));
		rat::raxpy(-x[j],a.row(j,j+1,n-1,1),xs0);
#else
//		rat::praxpy(-x[j],a.row(j,j+1,n-1,1),x.lsection(j+1,n-1,1));
		rat::praxpy(-x[j],a.row(j,j+1,n-1,1),xs0);
#endif
	}
//	for (int k=0; k < n; ++k) x[k] = x[k] / a[k][k];
	rat::lvector_section<rational> xs1(x,0,n-1,1);  // 2016jan26
#ifdef RBLAS
//	rat::rvdiv(a.diagonal(),x.lsection(0,n-1,1));
	rat::rvdiv(a.diagonal(),xs1);
#else
//	rat::prvdiv(a.diagonal(),x.lsection(0,n-1,1));
	rat::prvdiv(a.diagonal(),xs1);
#endif
	for (i=n-1; i >= 0; --i) {
//		for (int k=0; k <= i-1; ++k) x[k] = x[k] - a[k][i]*x[i];
		rat::lvector_section<rational> xs2(x,0,i-1,1);  // 2016jan26
#ifdef RBLAS
//		rat::raxpy(-x[i],a.column(i,0,i-1,1),x.lsection(0,i-1,1));
		rat::raxpy(-x[i],a.column(i,0,i-1,1),xs2);
#else
//		rat::praxpy(-x[i],a.column(i,0,i-1,1),x.lsection(0,i-1,1));
		rat::praxpy(-x[i],a.column(i,0,i-1,1),xs2);
#endif
	}
} 
