#ifndef RATUTIL_H
#define RATUTIL_H

#include <stdio.h>
#include <stdlib.h>
#include <string>
//#include "prblas.h"
#include "longint.h"
#include "rational.h"
#include "rvector.h"
#include "rmatrix.h"

//typedef vector<rational> rat::vector<rational>;
//typedef matrix<rational> rat::matrix<rational>;

int getdgts(rational v);

void MatDgtCount(const rat::matrix<rational>& a, const int m, const int n);
void MatDgtCountPrt(const rat::matrix<rational>& a, const int m, const int n);
void MtrDgtCount(const rat::matrix<rational>& a, const int n);
void MtrDgtCountPrt(const rat::matrix<rational>& a, const int n);
void VctDgtCount(const rat::vector<rational>& a, const int m);
void SeeMatDiag(const rat::matrix<rational>& a, const int n);
//void RedMatDgt(rat::matrix<rational>& a, const int n, const longint crit);
//void RedVecDgt(rat::vector<rational>& a, const int n, const longint crit);

void ScalMat(const rat::matrix<rational>& a, const int m, const int n, rat::vector<rational>& as, rat::matrix<rational>& aa);
void ScalVec(const rat::vector<rational>& a, const int n, rational& s, rat::vector<rational>& b, const int update);
rational ScalMatCol(rat::matrix<rational>& a, const int m, const int n, const int j, const int update);

int polydivchk(rat::vector<rational>& u, const int m, const rat::vector<rational>& v, const int n, rat::vector<rational>& q,  rat::vector<rational>& r);
int getpolynomial(const int k, rat::vector<rational>& cof, const int npolynomial, const rat::vector<int>& ppolynomial, const rat::vector<rational>& cpolynomial);
int putpolynomial(const int nsize, const rat::vector<rational>& cof, int npolynomial, rat::vector<int>& ppolynomial, rat::vector<rational>& cpolynomial);

void polytexform(const rat::vector<rational>& p,const  int nsize);
void polytexformr(const rat::vector<rational>& p,const  int nsize);
void polytexform2(const rat::vector<rational>& p,const int nsize, const rational& lcm);
void polytexformr2(const rat::vector<rational>& p, const int nsize, const rational& lcm);
void polytexformint(const rat::vector<rational>& p, const int nsize);
void polytexformintfmt(const rat::vector<rational>& p, const int nsize);
void polytexformintr(const rat::vector<rational>& p, const int nsize);

int askinty(const double t, const double epsint);
int askinty(const double t, const double epsint, rational& vrat);
int askinty(const rational& t, const double epsint, rational& vrat);
double vietaterm(const double e[], const int n, const int r);
rational vietaterm(const rat::vector<rational>& e, const int n, const int r);
int vietaterm(const rat::vector<rational>& ea, const rat::vector<rational>& eb, const int n, const int r, rational& ta, rational& tb);
int vietaterm(const rat::vector<rational>& e, const int n, const int r, rational& ta, rational& tb);
int vietaterm(const rat::vector<rational>& ea, const rat::vector<rational>& eb, const int n, const int r, rational& ta, rational& tb, const rat::vector<rational>& spa, const rat::vector<rational>& spb, rat::vector<rational>& ssa, rat::vector<rational>& ssb);
int cmpary(const int a[], const int b[], const int n);
void intmul(const rational& xa, const rational& xb, const rational& ya, const rational& yb, rational& za, rational& zb);

void nxtcmb(const int n, const int r, int ith[]);
void nxtcmb(const int n, const int r, int ith[], int chnj);
long long comb(const int n, const int r);
int bisectrf(const rat::vector<rational>& p, const int n, const double tol, const int maxit, rational& a, rational& fa, rational& b, rational& fb, rational& c);
int bisect(const rat::vector<rational>& p, const int n, const double tol, const int maxit, rational& a, rational& fa, rational& b, rational& fb, rational& c);
rational bestappfrac(const rational& c,const double tol);
rational Horner(const int n, const rat::vector<rational>& coef, const rational& x);
void Horner3(const int n, const rat::vector<rational>& coef, const rational& x, rational& r, rational& s, rational& t);
void Horner(const int n, const rat::vector<rational>& coef, const interval& x, rational& r, rational& s);
int bisectrf(const rat::vector<rational>& p, const int n, const double tol, const int maxit, interval& ab, rational& fa, rational& fb, rational& c);
int bisect(const rat::vector<rational>& p, const int n, const double tol, const int maxit, interval& ab, rational& fa, rational& fb, rational& c);

//void GenRmatMT(rat::matrix<rational>& a, const int m, const int n);
//void GenRvecMT(rat::vector<rational>& a, const int n);
//void GenRmat(rat::matrix<rational>& a, const int m, const int n, long long& iseed);
void GenRand(rat::matrix<rational>& a, const int n, const int r, long long& iseed);
void GenMat(rat::matrix<rational>& a, const int m, const int n, const int r, long long& iseed);
void SetRand2(rat::matrix<rational>& a, const int n, long long& iseed);
void SetRand(rat::matrix<rational>& a, const int n, long long& iseed);
void MyRND(long long& iseed, rational& drand);
void MyIRND(long long& iseed);
double urand( void );
void FloatUrandR(rat::matrix<rational>& a, const int m, const int n);
void FloatUrand(rat::matrix<rational>& a, const int n);
void SetFrank(rat::matrix<double>& a, const int n);
void SetFrank(rat::matrix<rational>& a, const int n);
void SetHilbert(rat::matrix<double>& a, const int n);
void SetHilbert(rat::matrix<rational>& a, int n);
void SetFtherm(rat::matrix<rational>& a, const int m, const int cont);
void SetFtherm(rat::matrix<double>& a, const int m);
void SetGLmat(rat::matrix<double>& a, const int m);
//void jacobi2(rat::matrix<double>& A,double tol,int n,int *itr);
int jacobev(rat::matrix<double>& A, rat::matrix<double>& V,double tol,int n,int maxit);
void bsort(rat::vector<double>& x, int n, int * ind);
void bsort(rat::vector<double>& x, int n);

interval roundrat(const rational& x, const int n);
interval roundrat2(const rational& x, const int n, const int m);
int newton(const rat::vector<rational>& p, const int n, const int tol, const int maxit, rational& a, rational& fa, rational& b, rational& fb, rational& c);
int newton(const rat::vector<rational>& p, const int n, const int tol, const int maxit, interval& ab, rational& fa, rational& fb, rational& c);

interval setpi(const uint32_t tol);
rational sqrt4g(const longint& a, const uint32_t tol);
rational SQR(const rational& a, const uint32_t tol);
interval SQRint(const rational& a, const uint32_t tol);
//interval sqrtnewton(const rational& tra, const uint32_t tol);

void cnvmat(const rat::matrix<double>& a, rat::matrix<rational>& ar, const int m, const int n);
void copymat(const rat::matrix<rational>& a, const int m, const int n, rat::matrix<rational>& c);
rational rat2int(const rat::matrix<rational>& a, const int n, rat::matrix<rational>& b);
longint matngcd(const rat::matrix<rational>& a, const int n);

void matprn(const rat::matrix<double>& a, const int m, const int n);
void matprn(const rat::matrix<rational>& a, const int m, const int n);
void matprt(const rat::matrix<rational>& a, const int m, const int n);

void elmhes(rat::matrix<rational>& a, const int n);
void hesfrb(rat::matrix<rational>& a, const int n, rat::vector<rational>& p);
void solhmg(rat::matrix<rational>& a, const int n, int& rank, rat::matrix<rational>& x);
void LUdecomp(rat::matrix<rational>& a, const int n, rat::vector<int>& ipvt, rat::vector<int>& jpvt, int& krank);
void LUsubst(const rat::matrix<rational>& a, const int n, rat::vector<rational>& x, const rat::vector<int>& ipvt, const rat::vector<int>& jpvt);
void LDL(rat::matrix<rational>& a, const int n);
void LDLsubst(const rat::matrix<rational>& a, const int n, rat::vector<rational>& x);
#endif
