/*
 * rtraits.h
 *
 *  Created on: 2014/08/19
 *      Author: Osamu
 */

#ifndef RTRAITS_H_
#define RTRAITS_H_
#include "rational.h"
#include "interval.h"
#include "rough.h"

class interval;

namespace rat
{
template<typename T> class vector;
template<typename T> class vector_section;
template<typename T> class lvector_section;
template<typename T> class matrix;
template<typename T> class matrix_section;
template<typename T> class lmatrix_section;
template<typename T> class matrix_column;
template<typename T> class lmatrix_column;
template<typename T> class matrix_row;
template<typename T> class lmatrix_row;
template<typename T> class matrix_diagonal;
template<typename T> class lmatrix_diagonal;

template<typename T> class vector_traits;
template<typename T> class matrix_traits;

template<>
class vector_traits<vector<int> >
{
public:
	typedef int ElementT;
};

template<>
class vector_traits<vector<double> >
{
public:
	typedef double ElementT;
};

template<>
class vector_traits<vector<rational> >
{
public:
	typedef rational ElementT;
};

template<>
class vector_traits<vector<interval> >
{
public:
	typedef interval ElementT;
};

template<>
class vector_traits<vector<rough> >
{
public:
	typedef rough ElementT;
};

template<>
class vector_traits<vector_section<int> >
{
public:
	typedef int ElementT;
};

template<>
class vector_traits<vector_section<double> >
{
public:
	typedef double ElementT;
};

template<>
class vector_traits<vector_section<rational> >
{
public:
	typedef rational ElementT;
};

template<>
class vector_traits<vector_section<rough> >
{
public:
	typedef rough ElementT;
};

template<>
class vector_traits<lvector_section<int> >
{
public:
	typedef int ElementT;
};

template<>
class vector_traits<lvector_section<double> >
{
public:
	typedef double ElementT;
};

template<>
class vector_traits<lvector_section<rational> >
{
public:
	typedef rational ElementT;
};

template<>
class vector_traits<lvector_section<rough> >
{
public:
	typedef rough ElementT;
};

// maritx_column
template<>
class vector_traits<matrix_column<int> >
{
public:
	typedef int ElementT;
};

template<>
class vector_traits<matrix_column<double> >
{
public:
	typedef double ElementT;
};

template<>
class vector_traits<matrix_column<rational> >
{
public:
	typedef rational ElementT;
};

template<>
class vector_traits<matrix_column<rough> >
{
public:
	typedef rough ElementT;
};

//
// lmaritx_column
//
template<>
class vector_traits<lmatrix_column<int> >
{
public:
	typedef int ElementT;
};

template<>
class vector_traits<lmatrix_column<double> >
{
public:
	typedef double ElementT;
};

template<>
class vector_traits<lmatrix_column<rational> >
{
public:
	typedef rational ElementT;
};

template<>
class vector_traits<lmatrix_column<rough> >
{
public:
	typedef rough ElementT;
};

// matrix_row

template<>
class vector_traits<matrix_row<int> >
{
public:
	typedef int ElementT;
};

template<>
class vector_traits<matrix_row<double> >
{
public:
	typedef double ElementT;
};

template<>
class vector_traits<matrix_row<rational> >
{
public:
	typedef rational ElementT;
};

template<>
class vector_traits<matrix_row<rough> >
{
public:
	typedef rough ElementT;
};


// lmatrix_row

template<>
class vector_traits<lmatrix_row<int> >
{
public:
	typedef int ElementT;
};

template<>
class vector_traits<lmatrix_row<double> >
{
public:
	typedef double ElementT;
};

template<>
class vector_traits<lmatrix_row<rational> >
{
public:
	typedef rational ElementT;
};

template<>
class vector_traits<lmatrix_row<rough> >
{
public:
	typedef rough ElementT;
};

// matrix diagonal

template<>
class vector_traits<matrix_diagonal<int> >
{
public:
	typedef int ElementT;
};

template<>
class vector_traits<matrix_diagonal<double> >
{
public:
	typedef double ElementT;
};

template<>
class vector_traits<matrix_diagonal<rational> >
{
public:
	typedef rational ElementT;
};

template<>
class vector_traits<matrix_diagonal<rough> >
{
public:
	typedef rough ElementT;
};

template<>
class vector_traits<lmatrix_diagonal<int> >
{
public:
	typedef int ElementT;
};

template<>
class vector_traits<lmatrix_diagonal<double> >
{
public:
	typedef double ElementT;
};

template<>
class vector_traits<lmatrix_diagonal<rational> >
{
public:
	typedef rational ElementT;
};

template<>
class vector_traits<lmatrix_diagonal<rough> >
{
public:
	typedef rough ElementT;
};

//
// matrix
//
template<>
class matrix_traits<matrix<int> >
{
public:
	typedef int ElementT;
	typedef vector<int> RowT;
};

template<>
class matrix_traits<matrix<double> >
{
public:
	typedef double ElementT;
	typedef vector<double> RowT;
};

template<>
class matrix_traits<matrix<rational> >
{
public:
	typedef rational ElementT;
	typedef vector<rational> RowT;
};

template<>
class matrix_traits<matrix<rough> >
{
public:
	typedef rough ElementT;
	typedef vector<rough> RowT;
};

template<>
class matrix_traits<matrix_section<int> >
{
public:
	typedef int ElementT;
	typedef vector<int> RowT;
};

template<>
class matrix_traits<matrix_section<double> >
{
public:
	typedef double ElementT;
	typedef vector_section<double> RowT;
};

template<>
class matrix_traits<matrix_section<rational> >
{
public:
	typedef rational ElementT;
	typedef vector_section<rational> RowT;
};

template<>
class matrix_traits<matrix_section<rough> >
{
public:
	typedef rough ElementT;
	typedef vector_section<rough> RowT;
};

template<>
class matrix_traits<lmatrix_section<int> >
{
public:
	typedef int ElementT;
	typedef vector<int> RowT;
};

template<>
class matrix_traits<lmatrix_section<double> >
{
public:
	typedef double ElementT;
	typedef lvector_section<double> RowT;
};

template<>
class matrix_traits<lmatrix_section<rational> >
{
public:
	typedef rational ElementT;
	typedef lvector_section<rational> RowT;
};

template<>
class matrix_traits<lmatrix_section<rough> >
{
public:
	typedef rough ElementT;
	typedef lvector_section<rough> RowT;
};

}
#endif /* RTRAITS_H_ */
